//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// Use of this source code is subject to the terms of the Microsoft end-user
// license agreement (EULA) under which you licensed this SOFTWARE PRODUCT.
// If you did not accept the terms of the EULA, you are not authorized to use
// this source code. For a copy of the EULA, please see the LICENSE.RTF on your
// install media.
//
/***********************************************************************

MODULE: 
  CeDialer.h

ABSTRACT: 
  This is a header file of the CeDialer Windows CE sample application.

***********************************************************************/

#ifndef _CEDIALER_H_
#define _CEDIALER_H_



//#include "tapi.h"
//#include "Winbase.h"




class CeDialer{

private:
	HWND m_hwnd;



public:
	
	CeDialer(HWND);
	~CeDialer();
	int Start(LPCTSTR lpszPhoneNum);
	int Stop();
	void setVerbosity(int v);
	void set_micOn();
	void set_micOff();

};





typedef struct tagLINEINFO
{
  HLINE hLine;              // Line handle returned by lineOpen
  BOOL  bVoiceLine;         // Indicates if the line is a voice line
  DWORD dwAPIVersion;       // API version that the line supports
  DWORD dwNumOfAddress;     // Number of available addresses on the line
  DWORD dwPermanentLineID;  // Permanent line identifier
  TCHAR szLineName[256];    // Name of the line
} LINEINFO, *LPLINEINFO;


//int WINAPI WinMain (HINSTANCE, HINSTANCE, LPTSTR, int);

//BOOL CALLBACK MainWndProc (HWND, UINT, WPARAM, LPARAM);
//BOOL CALLBACK DialingProc (HWND, UINT, WPARAM, LPARAM);
//BOOL CALLBACK ConnectUsingProc (HWND, UINT, WPARAM, LPARAM);
//VOID CALLBACK tapiCallback (DWORD, DWORD, DWORD, DWORD, DWORD, DWORD);

DWORD InitializeTAPI ();
DWORD GetLineInfo (DWORD, LPLINEINFO);
VOID MakePhoneCall (LPCTSTR);
VOID CurrentLineClose ();
VOID HangupCall ();
int micOn();
int micOff();


BOOL MakeCanonicalNum (LPTSTR);
BOOL InitLineCB (HWND, DWORD, DWORD);
BOOL InitAddrCB (HWND, HWND, DWORD, DWORD);


#endif 


