#ifndef __PRESARATA_BROWSER_EVENTS_H
#define __PRESARATA_BROWSER_EVENTS_H
#include <objbase.h>
//Web Browser Control Event dispIDs
#define BROWSER_EVENT_BEFORE_NAVIGATE           0x64
#define BROWSER_EVENT_COMMAND_STATE_CHANGE      0x69
#define BROWSER_EVENT_DOWNLOAD_BEGIN            0x6a
#define BROWSER_EVENT_DOWNLOAD_COMPLETE         0x68
#define BROWSER_EVENT_FRAME_BEFORE_NAVIGATE     0xc8
#define BROWSER_EVENT_FRAME_NAVIGATE_COMPLETE   0xc9
#define BROWSER_EVENT_NAVIGATE_COMPLETE         0x65
#define BROWSER_EVENT_NEW_WINDOW                0x6b
#define BROWSER_EVENT_TITLE_CHANGE              0x71


#define IDC_SEND_TO_SOCKET WM_USER + 28
#define IDC_STOP_BROWSE WM_USER + 30


class CMustClientEvents : public IDispatch
{
private:
	LONG m_cRef;
    HWND m_hwndBrowser;  //For use in MessageBoxes, etc.
	
public:
	HWND m_hwndEdit; // Debug window
	CMustClientEvents(PVOID);
	virtual ~CMustClientEvents() {}
	/* IUnknown Methods */
	virtual STDMETHODIMP QueryInterface(
		REFIID refiid,
		void** ppv);
	virtual STDMETHODIMP_(ULONG) AddRef();
	virtual STDMETHODIMP_(ULONG) Release();

	/* IDispatch Methods */
	virtual STDMETHODIMP GetTypeInfoCount(
		UINT* pctinfo
		);
	virtual STDMETHODIMP GetTypeInfo(
		UINT iTInfo,
		LCID lcid,
		ITypeInfo** ppTInfo
		);
	virtual STDMETHODIMP GetIDsOfNames(
		const IID& riid,
		LPOLESTR* rgszNames,
		UINT cNames,
		LCID lcid,
		DISPID* rgDispId
		);
	virtual STDMETHODIMP Invoke(
		DISPID dispIdMember,
		const IID& riid,
		LCID lcid,
		WORD dwFlags,
		DISPPARAMS* pDispParams,
		VARIANT* pVarResult,
		EXCEPINFO* pExcepInfo,
		UINT* puArgErr
		);
};

#endif //__PRESARATA_BROWSER_EVENTS_H
