/*
    File:       webview.h

    Contains:   This file contains the declaration of the
    			COM interfaces of webview.dll for Windows CE.
*/


#ifndef __WEBVIEW_H
#define __WEBVIEW_H


struct __declspec(uuid("698e3fc9-70c3-11d0-81e8-00a0c90ad20a")) IBrowser;

struct __declspec(uuid("698e3fc9-70c3-11d0-81e8-00a0c90ad20a"))
IBrowser : IDispatch
{
    //
    // Raw methods provided by interface
    //

    virtual HRESULT __stdcall Navigate (
        BSTR bstrURL,
        long dwFlags,
        BSTR bstrTargetFrameName,
        BSTR bstrPostData ) = 0;
    virtual HRESULT __stdcall Refresh ( ) = 0;
    virtual HRESULT __stdcall Stop ( ) = 0;
    virtual HRESULT __stdcall get_Busy (
        long * pVal ) = 0;
    virtual HRESULT __stdcall get_Title (
        BSTR * pVal ) = 0;
    virtual HRESULT __stdcall get_LocationURL (
        BSTR * pVal ) = 0;
    virtual HRESULT __stdcall get_IsFrame (
        long * pVal ) = 0;
    virtual HRESULT __stdcall put_IsFrame (
        long pVal ) = 0;
    virtual HRESULT __stdcall get_ScrollStyle (
        long * pVal ) = 0;
    virtual HRESULT __stdcall put_ScrollStyle (
        long pVal ) = 0;
    virtual HRESULT __stdcall get_MarginWidth (
        long * pVal ) = 0;
    virtual HRESULT __stdcall put_MarginWidth (
        long pVal ) = 0;
    virtual HRESULT __stdcall get_MarginHeight (
        long * pVal ) = 0;
    virtual HRESULT __stdcall put_MarginHeight (
        long pVal ) = 0;
    virtual HRESULT __stdcall FrameNavigate (
        BSTR bstrURL,
        BSTR bstrTarget,
        BSTR bstrSource,
        BSTR bstrPostData,
        long * Cancel ) = 0;
};
extern "C" const GUID __declspec(selectany) IID_IBrowser =
    {0x698e3fc9,0x70c3,0x11d0,{0x81,0xe8,0x00,0xa0,0xc9,0x0a,0xd2,0x0a}};

// {A02531D1-7050-11d3-A5C2-00A0CC537F0A}
static const GUID CLSID_Browser = 
{ 0x698E3FCA, 0x70C3, 0x11d0, { 0x81, 0xe8, 0x0, 0xa0, 0xc9, 0x0a, 0xd2, 0x0a } };
#endif /* __WEBVIEW_H */