// Tools.cpp: implementation of the CTools class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Tools.h"

// The ErrorMessageBox shows a messagebox with error information
// from the program and the last error from windows.

void ErrorMessageBox(PWCHAR pwcError)
{
    WCHAR szErrorMessage[256];
    LPVOID lpMsgBuf;
    FormatMessage( 
	    FORMAT_MESSAGE_ALLOCATE_BUFFER | 
	    FORMAT_MESSAGE_FROM_SYSTEM | 
	    FORMAT_MESSAGE_IGNORE_INSERTS,
	    NULL,
	    GetLastError(),
	    0, // Default language
	    (LPTSTR) &lpMsgBuf,
	    0,
	    NULL 
	    ); 

    wsprintf(szErrorMessage,L"%s.\r\nError message from windows:\r\n % s",pwcError,lpMsgBuf);
    ::MessageBox(NULL,szErrorMessage,L"Error",MB_OK);

}

// The FindAndRepaceStr function find a sub string and replace it with another
// string. The replace string can be larger/less than the
// orginal string.

void FindAndRepaceStr(PWCHAR pszInput,PWCHAR pwszRepace, PWCHAR pwszFind)
{
    PWCHAR pszSearch = NULL;
    DWORD dwLength = 0, dwReplaceLength = 0, dwFindLength = 0,dwTempIndex = 0;
    PWCHAR pszTemp = new WCHAR[wcslen(pszInput) + 1]; 
    
    wcscpy(pszTemp,pszInput);  
    dwReplaceLength = wcslen(pwszRepace);
    dwFindLength = wcslen(pwszFind);
    pszSearch = pszInput;
   
    do {
        if(pszSearch = wcsstr(pszSearch,pwszFind)) {
            dwLength = pszSearch - pszInput;
            wcscpy(&pszInput[dwLength],pwszRepace);
            wcscpy(&pszInput[dwLength + dwReplaceLength],&pszTemp[dwLength + dwTempIndex + dwFindLength]);
            dwTempIndex += (dwFindLength - dwReplaceLength);
            pszSearch++;
        }
    } while(pszSearch);

    delete [] pszTemp;
}

// The CreateLogFont function create a logical font that has specific 
// characteristics. In Win 32 there is a function for this called
// CreateFont, but this function is not supportet for ATL under
// Win Pocket PC.

LOGFONT CreateLogFont
(
 
  int nHeight,             // logical height of font
  int nWidth,              // logical average character width
  int nEscapement,         // angle of escapement
  int nOrientation,        // base-line orientation angle
  int fnWeight,            // font weight
  BYTE fdwItalic,         // italic attribute flag
  BYTE fdwUnderline,      // underline attribute flag
  BYTE fdwStrikeOut,      // strikeout attribute flag
  BYTE fdwCharSet,        // character set identifier
  BYTE fdwOutputPrecision,  // output precision
  BYTE fdwClipPrecision,  // clipping precision
  BYTE fdwQuality,        // output quality
  BYTE fdwPitchAndFamily,  // pitch and family
  PTCHAR  lpszFace         // pointer to typeface name string
)

{
    LOGFONT lf; 
	
	lf.lfHeight = nHeight; 
	lf.lfWidth = nWidth;
	lf.lfEscapement = nEscapement;
	lf.lfOrientation = nOrientation;
	lf.lfWeight = fnWeight;
	lf.lfItalic = fdwItalic;
	lf.lfUnderline = fdwUnderline;
	lf.lfStrikeOut = fdwStrikeOut;
	lf.lfCharSet = fdwCharSet;
	lf.lfOutPrecision = fdwOutputPrecision;
	lf.lfClipPrecision = fdwClipPrecision;
	lf.lfQuality = fdwQuality;
	lf.lfPitchAndFamily = fdwPitchAndFamily;

	wcscpy(lf.lfFaceName,lpszFace);

    return lf;
}
 














