#include "stdafx.h"
#include "Winbase.h"
#include "VOImage.h"
#include "Wingdi.h"
#include "Wininet.h"




#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif

HINTERNET hHTTPInternetSession;
INLINEIMAGEINFO iii;



//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

HDC		CVOImage::g_hdc;
int		CVOImage::g_iScale = 100;
int		CVOImage::g_iMaxWidth = 10000;
int		CVOImage::g_iMaxHeight = 10000;
BOOL	CVOImage::g_bStretchBlt = FALSE;



CVOImage::CVOImage()
{
	m_hbitmap = 0;
#ifndef UNDER_CE
	g_dwPictureCount = 0;
#endif
}

CVOImage::~CVOImage()
{
	if(m_hbitmap)
		DeleteObject(m_hbitmap);

#ifndef UNDER_CE

	for(int i=0;i<100;i++) {
		if(spIPicture[i] !=NULL){
			spIPicture[i]->Release();
		}
	}
#endif
	
}


LPVOID MyAllocMem( DWORD cb)
{
  return HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, cb); 
} 

BOOL MyFreeMem( LPVOID pMem)
{
  return HeapFree(GetProcessHeap(), 0, pMem);
}

/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::LoadBkImage
//
// COMMENT: Loads a background image from file
//        
/////////////////////////////////////////////////////////////////////////////
BOOL CVOImage::LoadBkImage(HINSTANCE hIns,HDC hdc, LPCTSTR pcszFileName, LPCTSTR pszLocalPathName)
{
	if(m_hbitmap)
		DeleteObject(m_hbitmap);

	if(!g_hdc)
		g_hdc = CreateCompatibleDC(hdc);


    if(!(m_hbitmap = LoadCompressedImage(hIns,g_hdc,pcszFileName,pszLocalPathName)))
        return FALSE;

    BITMAP	bmp;
	
	::GetObject(m_hbitmap, sizeof(BITMAP), &bmp);

	m_dwWidth = bmp.bmWidth;
	m_dwHeight = bmp.bmHeight;

	
    return TRUE;


}
/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::LoadImage
//
// COMMENT: Loads a JPEG/GIF file from a URL or a local path. When the file
// is loaded a decompress algorithm convert the file to a bitmap.
//        
/////////////////////////////////////////////////////////////////////////////
HBITMAP CVOImage::LoadCompressedImage(HINSTANCE hIns,HDC hdc,LPCTSTR pcszFileName, LPCTSTR pszLocalPathName)
{
    PWCHAR pszURL = L"http://", pStr = NULL;
    HINTERNET hInternetSession = NULL, hOpenUrlHandle = NULL; 
    DWORD dwNumberOfBytesFromServer = 0, dwNumberOfBytesWritten = 0;
    DWORD dwSize = 0, dwDataSize = 40000;
    PCHAR Data = NULL;
    HANDLE hFile = INVALID_HANDLE_VALUE;;
    HBITMAP hbitmap;
    DWORD dwLength = 0, dwAccessType = INTERNET_OPEN_TYPE_DIRECT;



#ifdef UNDER_CE
	BYTE  szBuffer[30000] = {0};
	DWORD dwBufferMax = 30000;
#else
	BYTE  szBuffer[60000] = {0};
	DWORD dwBufferMax = 60000;
	DWORD dwReadNumberOfBytes;
#endif

    HRESULT hr;
	ImageDataHandler *imgData = NULL;


#ifdef UNDER_CE
    DecompressImageInfo	dii;
#endif

	// OLE interface used for creating picture under 
	//CComPtr<IPictureDisp>spIPictureDisp;

    // Loads file from URL

#ifdef UNDER_CE	

    if(!wcsnicmp(pcszFileName,pszURL,wcslen(pszURL))) {
        // Initialize an internet handle
        if ((hHTTPInternetSession = ::InternetOpen(L"Map Application", INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, 0)) == NULL) {
            ErrorMessageBox(L"Can't open internet session.");
            if(hHTTPInternetSession) InternetCloseHandle(hHTTPInternetSession);
			hHTTPInternetSession = NULL;
			return NULL;
        }
	
		imgData = (ImageDataHandler *)MyAllocMem(sizeof(ImageDataHandler));
		imgData->lpFileName = MyAllocMem(sizeof( TCHAR ) * (wcslen(pcszFileName) + 1 ));
		wsprintf(( LPTSTR ) imgData->lpFileName, TEXT( "%s" ), ( LPTSTR )pcszFileName );
		//::MessageBox(NULL,(LPWSTR) imgData->lpFileName , L"Error", MB_OK);

	/*	dii.dwSize = sizeof( DecompressImageInfo );
		dii.pbBuffer = szBuffer;
		dii.dwBufferMax = dwBufferMax;
		dii.dwBufferCurrent = 0;
		dii.phBM = NULL;
		dii.ppImageRender = NULL;
		dii.iBitDepth = GetDeviceCaps(hdc,BITSPIXEL);
		dii.lParam = ( LPARAM ) imgData;
		dii.hdc = hdc;
		dii.iScale = g_iScale;
		dii.iMaxWidth = g_iMaxWidth;
		dii.iMaxHeight = g_iMaxHeight;
		dii.pfnGetData = GetImageDataFromURL;
		dii.pfnImageProgress = ImageProgressFromURL;
		dii.crTransparentOverride = ( UINT ) -1;

::MessageBox(NULL,L"Enter decompimagedirect", L"Error", MB_OK);

		hr = DecompressImageIndirect( &dii );

::MessageBox(NULL,L"Exit decompimagedirect", L"Error", MB_OK);

		// Done with the callback function => get the bitmap handler

		hbitmap = iii.hbm; */

        hbitmap = LoadImageWithImagingApi((VOID *)szBuffer, dwBufferMax, imgData);//(_T("Overview.gif"));
		
		MyFreeMem(imgData->lpFileName);
		MyFreeMem(imgData);
       
	// Loads file from a local path
    } else {
		hFile = CreateFile(pcszFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
			
		if (hFile == INVALID_HANDLE_VALUE) {
			WCHAR szBuf[256];
			wsprintf(szBuf,L"Can't create file: %s",pcszFileName);
			ErrorMessageBox(szBuf);
			CloseHandle(hFile);
			return NULL;
		}
		// Fill in the 'DecompressImageInfo' structure
		dii.dwSize = sizeof( DecompressImageInfo );		// Size of this structure
		dii.pbBuffer = szBuffer;						// Pointer to the buffer to use for data
		dii.dwBufferMax = dwBufferMax;							// Size of the buffer
		dii.dwBufferCurrent = 0;						// The amount of data which is current in the buffer
		dii.phBM = &hbitmap;							// Pointer to the bitmap returned (can be NULL)
		dii.ppImageRender = NULL;						// Pointer to an IImageRender object (can be NULL)
		dii.iBitDepth = GetDeviceCaps(hdc,BITSPIXEL);	// Bit depth of the output image
		dii.lParam = ( LPARAM ) hFile;					// User parameter for callback functions
		dii.hdc = /*g_hdc*/hdc;								// HDC to use for retrieving palettes
		dii.iScale = g_iScale;							// Scale factor (1 - 100)
		dii.iMaxWidth = g_iMaxWidth;					// Maximum width of the output image
		dii.iMaxHeight = g_iMaxHeight;					// Maxumum height of the output image
		dii.pfnGetData = GetImageDataFromFile;			// Callback function to get image data
		dii.pfnImageProgress = ImageProgressFromFile;	// Callback function to notify caller of progress decoding the image
		dii.crTransparentOverride = ( UINT ) -1;		// If this color is not (UINT)-1, it will override the
														// transparent color in the image with this color. (GIF ONLY)

		// Process and decompress the image data
		hr = DecompressImageIndirect(&dii);
			// Clean up 
		CloseHandle(hFile);
	}
#else

    USES_CONVERSION;
	// Load a picture from a file or URL
	 hr = OleLoadPicturePath( 
		T2OLE((PWCHAR)pcszFileName), 
		NULL, 
		0, 
		NULL, 
		IID_IPicture , 
		reinterpret_cast<void**>(&spIPicture[g_dwPictureCount]));

	if(FAILED(hr)) {
		WCHAR szBuf[256];
		wsprintf(szBuf,L"Can't Load picture: %s",pcszFileName);
		ErrorMessageBox(szBuf);
	}

	// get handle of the bitmap
	hr=spIPicture[g_dwPictureCount]->get_Handle((OLE_HANDLE FAR*)  &hbitmap);
	
	if(FAILED(hr)) {
		WCHAR szBuf[256];
		wsprintf(szBuf,L"IPicture method get_Handle fails: %s",pcszFileName);
		ErrorMessageBox(szBuf);
	}

	g_dwPictureCount++;

#endif
		
	return hbitmap;
}

HBITMAP CVOImage::LoadHotSpotImageFile(HINSTANCE hIns,HDC hdc, LPCTSTR pcszFileName, LPCTSTR pszLocalPathName)
{    
    HBITMAP hBm;
    HDC com_hDC = NULL;
	com_hDC = CreateCompatibleDC(hdc);
    hBm = LoadCompressedImage(hIns,com_hDC,pcszFileName,pszLocalPathName);
    DeleteDC(com_hDC);
    return hBm;
}

HBITMAP CVOImage::LoadImageWithImagingApi( VOID* szBuffer, DWORD dwBufferMax,   ImageDataHandler *ihandler )
{
    IImagingFactory *pImgFactory = NULL;
    IImage *pImage = NULL;
    CoInitializeEx(NULL, COINIT_MULTITHREADED);
   HBITMAP hResult = 0;
    if (SUCCEEDED(CoCreateInstance (CLSID_ImagingFactory,
                                    NULL,
                                    CLSCTX_INPROC_SERVER,
                                    IID_IImagingFactory,
                                    (void **)&pImgFactory)))
    {
		ImageInfo imageInfo;
		DWORD read_bytes;
		
	
		
		LPTSTR url;
		url = (LPTSTR) ihandler->lpFileName;

		
		
		
	
	
		DWORD slen = wcslen(url);
		DWORD fil_ini=0; 
			for(int i=slen; i>0; i--){
				if (url[i] == '/') {
					fil_ini=i;
				break;}
			}

		int sum = slen-(fil_ini+2);
		LPTSTR fil;
		fil =  new WCHAR[slen-(fil_ini-1)];
		int j=0;
			
			for(int i=fil_ini+1; i<slen; i++){
				fil[j]=url[i];
				j++;
			} 
    
		fil[j]='\0';
		

		int flen = wcslen(fil);
		LPTSTR pathfile = new WCHAR[20+flen];
		//TCHAR pathfile2[256];
		//wsprintf(pathfile2, '\\Temp\\', (LPTSTR)ImageHandler->lpFileName);

					pathfile[0] = '\\';
					pathfile[1] = 'T';
					pathfile[2] = 'e';
					pathfile[3] = 'm';
					pathfile[4] = 'p';
					pathfile[5] = '\\';
					
					
					int l = 0;
					int k = 0;

					for(k =6; k<=wcslen(fil)+6; k++)
					{	
						pathfile[k] = fil[l];
						l++;
						
					}
					
					pathfile[k]='\0';
		
		
		read_bytes =GetImageFromFile2Buffer((LPSTR)szBuffer, dwBufferMax, pathfile);
		
		if(read_bytes ==0){
			
			DWORD dwTimeElapsed;
			DWORD dwOldTime; 
			
			dwOldTime = GetTickCount();
			
			read_bytes =GetImageFromURL2Buffer((LPSTR)szBuffer, dwBufferMax, ihandler );
				 
			dwTimeElapsed = GetTickCount() - dwOldTime;

			DWORD dwTransferSpeed = (8*read_bytes)/(dwTimeElapsed/100);
	
			FILE *stream;
					   
				
			
					if( (stream = fopen( "\\Temp\\time.txt", "a" )) != NULL )
						{	
						fprintf(stream, "%s ", fil); 
						fprintf(stream, "%s ", " size: "); 
						fprintf( stream, "%d ", read_bytes );
						fprintf(stream, "%s ", " time used "); 
						fprintf( stream, "%d ", dwTimeElapsed );
						fprintf(stream, "%s", " ms "); 
						fprintf(stream, "%d ", dwTransferSpeed);
						fprintf(stream, "%s\n", " bits/s "); 
						fclose( stream );
					}

					
					HANDLE hfile; 
					
					hfile = CreateFile(pathfile, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
				
					//LPDWORD lpNumberOfBytesWritten; // DWORD *lp;
					DWORD  NumberOfBytesWritten;
					if(WriteFile(hfile,  (VOID *) szBuffer, /*dwBufferMax*/read_bytes, (LPDWORD)&NumberOfBytesWritten, /*lpNumberOfBytesWritten,*/ NULL )){
						//CloseHandle(hfile);
						if (read_bytes != NumberOfBytesWritten){
							::MessageBox(NULL, L"could not written to the file", L"error", MB_OK);						}
					}
	
					CloseHandle(hfile);

					int fel = GetLastError();

		}

		if (read_bytes != 0){ 
			if (SUCCEEDED(pImgFactory->CreateImageFromBuffer((VOID *) szBuffer,dwBufferMax,BufferDisposalFlagNone,&pImage)) //(WCHAR *)strFileName, &pImage))
				&& SUCCEEDED(pImage->GetImageInfo(&imageInfo)))
			{
				HDC hDC; //CWindowDC dc(0); //Display device context
				hDC =GetDC(NULL); // Get the dc of whole window 
				HDC hDCMem; //CDC dcBitmap; //Memory device context
				hDCMem= CreateCompatibleDC(hDC); //dcBitmap.CreateCompatibleDC(&dc);
				//hResult = CreateCompatibleBitmap(dc.GetSafeHdc(), imageInfo.Width, imageInfo.Height);
				hResult = CreateCompatibleBitmap(hDC, imageInfo.Width, imageInfo.Height);
				if (hResult) {
					//HGDIOBJ hOldBitmap = dcBitmap.SelectObject(hResult);
					HGDIOBJ hOldBitmap = SelectObject(hDCMem, hResult);
					// pImage->Draw(dcBitmap.GetSafeHdc(), CRect(0, 0, imageInfo.Width, imageInfo.Height), NULL);
					RECT tmp_rect; tmp_rect.left=0; tmp_rect.top=0; tmp_rect.right=imageInfo.Width; tmp_rect.bottom= imageInfo.Height;
					pImage->Draw(hDCMem,&tmp_rect , NULL);
					//dcBitmap.SelectObject(hOldBitmap);
					SelectObject(hDCMem, hOldBitmap);
				}
				pImage->Release();
			}
			pImgFactory->Release();
		}
	}
	CoUninitialize();

   return hResult;
}


/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::Copy
//
// COMMENT: Make a copy of an image
//        
/////////////////////////////////////////////////////////////////////////////
HBITMAP CVOImage::Copy()
{
	BITMAP	bm, bmNew;
	HBITMAP hNew;

	SelectObject(g_hdc, m_hbitmap);

	::GetObject(m_hbitmap, sizeof(BITMAP), &bm);

	HDC hdc = CreateCompatibleDC(g_hdc);
	hNew = CreateCompatibleBitmap(g_hdc, bm.bmWidth, bm.bmHeight);
	SelectObject(hdc, hNew);

	if(BitBlt(hdc, 0, 0, bm.bmWidth, bm.bmHeight, g_hdc, 0, 0, SRCCOPY))
	{
		HBITMAP hPrev = (HBITMAP) ::GetObject(hNew, sizeof(BITMAP), &bmNew);
			
		::SelectObject(hdc, hPrev);
	}

	DeleteDC(hdc);
	return hNew;
}

/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::CopyPartOfImage
//
// COMMENT: Copy a part of an image into a new image
//        
/////////////////////////////////////////////////////////////////////////////
HBITMAP CVOImage::CopyPartOfImage(int nXSource, int nYSource,int nWidth,int nHeight)
{
	BITMAP	bm, bmNew;
	HBITMAP hNew;

	SelectObject(g_hdc, m_hbitmap);

	::GetObject(m_hbitmap, sizeof(BITMAP), &bm);

	HDC hdc = CreateCompatibleDC(g_hdc);
	hNew = CreateCompatibleBitmap(g_hdc, nWidth, nHeight);
	SelectObject(hdc, hNew);

	if(BitBlt(hdc,0,0, nWidth, nHeight, g_hdc, nXSource, nYSource,SRCCOPY))
	{
		HBITMAP hPrev = (HBITMAP) ::GetObject(hNew, sizeof(BITMAP), &bmNew);
			
		::SelectObject(hdc, hPrev);
	}

	DeleteDC(hdc);
	return hNew;
}

/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::PaintHotSpot
//
// COMMENT: Paint a hotspot. The hotspot can be a text (transparent
// or with background color), ellipse or a rectangle. The ellipse and rectangle
// can be filled with colors, or pixels from the main background image.
//        
/////////////////////////////////////////////////////////////////////////////
BOOL CVOImage::PaintHotSpot(HDC hDC,HOTSPOT hs)
{
	return PaintItem(hDC, hs.hRgn, hs.font, hs.szShapeType, hs.szText, 
					 hs.crFillerColor, hs.crBorderColor, hs.bFiller,hs.bBorder,hs.dwBorderWidth,hs.dwPenWidth);
}

/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::Event
//
// COMMENT: Paint an event. The event can be a text (transparent
// or with background color), ellipse or a rectangle. The ellipse and rectangle
// can be filled with colors, or pixels from the main background image.
//        
/////////////////////////////////////////////////////////////////////////////
BOOL CVOImage::PaintEvent(HDC hDC,EVENT ev)
{
	return PaintItem(hDC, ev.hRgn, ev.font, ev.szShapeType, ev.szText, 
						 ev.crEventFillerColor, ev.crEventBorderColor,ev.bFiller,ev.bBorder,
						 ev.dwBorderWidth,ev.dwPenWidth);
}

/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::PaintItem
//
// COMMENT: Do the paint work for the methods CVOImage::PaintEvent and
// CVOImage::PaintHotSpot
//        
/////////////////////////////////////////////////////////////////////////////
BOOL CVOImage::PaintItem(HDC hDC,HRGN hRgn, FONT font, PTCHAR szShapeType, PTCHAR szText, 
						 COLORREF crFillerColor, COLORREF crBorderColor, BOOL bFiller, BOOL bBorder, DWORD dwBorderWidth, DWORD dwPenWidth)
{
	HPEN hPen, hOldPen;
    RECT rc;
    HBRUSH hBrush, hOldBrush;

    
    GetRgnBox(hRgn,&rc);
    
    // Paint text 
    if(!_wcsicmp(szShapeType,L"TEXT")) {

        HFONT hf;
      
        LOGFONT lf = CreateLogFont(font.dwFontSize, 0, 0, 0, 400, font.bItalic, font.bUnderLine,      
            0, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
            DRAFT_QUALITY, DEFAULT_PITCH | FF_SWISS, font.szFontType);

        hf = (HFONT) SelectObject(hDC,CreateFontIndirect(&lf));

	
		if(bBorder)
			hPen = ::CreatePen (PS_SOLID, dwPenWidth, crBorderColor);
		else
			hPen = ::CreatePen (PS_SOLID, dwPenWidth, font.crTextBkColor);

		hOldPen =(HPEN) SelectObject(hDC, hPen);
		
		hBrush = CreateSolidBrush(font.crTextBkColor);

		hOldBrush = (HBRUSH)SelectObject(hDC, hBrush);

		SetTextColor(hDC,font.crTextColor);
		    
	    // Paint the background color and the font color
        if(font.bTransparent) 
            SetBkMode(hDC, TRANSPARENT); 
        else {

           //SetBkColor(hDC,font.crTextBkColor);
			Rectangle(hDC,rc.left, rc.top, rc.right, rc.bottom);		
	        SetBkMode(hDC, TRANSPARENT); 
		}

        rc.top += dwBorderWidth;
		rc.left += dwBorderWidth;
		rc.right -= dwBorderWidth;
		rc.bottom -= dwBorderWidth;

        DrawText(hDC,szText, _tcslen(szText), &rc,DT_WORDBREAK);
   
		SelectObject (hDC, hOldPen);
        DeleteObject (hPen);

		SelectObject(hDC, hOldBrush);
        DeleteObject(hBrush);
	
        DeleteObject(SelectObject(hDC,hf));

    } else {
        
		hPen = ::CreatePen (PS_SOLID, dwPenWidth, crBorderColor);
		if(bFiller) {
			hBrush = CreateSolidBrush(crFillerColor);
		} else {
			hBrush = CreatePatternBrush(m_hbitmap);
		}
        
        hOldBrush = (HBRUSH)SelectObject(hDC, hBrush);
		hOldPen =(HPEN) SelectObject(hDC, hPen);

        // Draw a rectangle
        if(!_wcsicmp(szShapeType,L"Rectangle")) {
			if(bFiller) {
				Rectangle(hDC,rc.left, rc.top, rc.right, rc.bottom);
			} else {
#ifdef _WIN32_WCE_EMULATION
				// Needed to write the DrawRect function instead of
				// the standard function Rectangle, because the emulator 
				// didn't work with this function and BRUSH created from 
				// CreatePatternBrush() (but it work on WinNT and the iPaq). 
				PaintRectangle(hDC,hRgn);
#else
				Rectangle(hDC,rc.left, rc.top, rc.right, rc.bottom);
#endif
			}
        // Draw an ellipse
       } else if (!_wcsicmp(szShapeType,L"Ellipse")) {
			if(bFiller) {
				Ellipse(hDC, rc.left, rc.top, rc.right, rc.bottom);
			} else {
#ifdef _WIN32_WCE_EMULATION
				// Needed to write the DrawEllipse function instead of
				// the standard function Ellipse. 
				PaintEllipse(hDC,hRgn);
#else
				Ellipse(hDC,rc.left, rc.top, rc.right, rc.bottom);
#endif		
			}
        } 

        SelectObject (hDC, hOldPen);
        DeleteObject (hPen);
		SelectObject(hDC, hOldBrush);
        DeleteObject(hBrush);
		
    }

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::PaintRectangle
//
// COMMENT: Paint a rectangle. Only needed for the emulator. 
//        
/////////////////////////////////////////////////////////////////////////////
BOOL CVOImage::PaintRectangle(HDC hDC, HRGN hRgn)
{

	RECT rect;
	POINT ptRect[5];    
	
	GetRgnBox(hRgn,&rect); 

	ptRect[0].x = rect.left;
	ptRect[0].y = rect.top;
	ptRect[1].x = rect.right;
	ptRect[1].y = rect.top;
	ptRect[2].x = rect.right;
	ptRect[2].y = rect.bottom;
	ptRect[3].x = rect.left;
	ptRect[3].y = rect.bottom;
	ptRect[4].x = rect.left;
	ptRect[4].y = rect.top;

	// Paint a straight line connecting the two points.
	Polyline (hDC, ptRect, 5);


	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::PaintEllipse
//
// COMMENT: Paint an ellipse. Only needed for the emulator. 
//        
/////////////////////////////////////////////////////////////////////////////
BOOL CVOImage::PaintEllipse(HDC hDC, HRGN hRgn)
{

	RECT rect;    
	POINT ptEllipse[3600];
	
	GetRgnBox(hRgn,&rect); 

	double pi = 3.1415926535;

	int dwSize = sizeof(ptEllipse)/sizeof(POINT);

	for (int i=0; i < dwSize;i++) {
		ptEllipse[i].x = (LONG)((rect.left + ((rect.right-rect.left)/2))
			- (((rect.right-rect.left)/2) * cos(-(2*i*pi)/dwSize)));
		ptEllipse[i].y = (LONG)((rect.top + ((rect.bottom-rect.top)/2)) 
			+ (((rect.bottom-rect.top)/2) * sin(-(2*i*pi)/dwSize)));
	}

	// Paint ellipse

	Polyline(hDC,ptEllipse,dwSize);
		
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::Draw
//
// COMMENT: Draw an image. 
//        
/////////////////////////////////////////////////////////////////////////////
BOOL CVOImage::Draw(HDC hdc, int x, int y, int cx, int cy)
{
	BITMAP	bmp;
	HGDIOBJ	hOldBitmap;

	g_bStretchBlt = !(cx == -1 && cy == -1);
	hOldBitmap = SelectObject(g_hdc, m_hbitmap);
	GetObject(m_hbitmap, sizeof(BITMAP), &bmp);

	if (g_bStretchBlt)
	{
		StretchBlt(hdc, x , y, cx, cy, g_hdc,0,0, bmp.bmWidth, bmp.bmHeight,SRCCOPY );
	}
	else
	{
		BitBlt(hdc, x, y, bmp.bmWidth, bmp.bmHeight, g_hdc,0,0,SRCCOPY );
	}

	SelectObject(g_hdc, hOldBitmap);

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::DrawPartOfImage
//
// COMMENT: Draw a rectangular region of an image. 
//        
/////////////////////////////////////////////////////////////////////////////
BOOL CVOImage::DrawPartOfImage(HDC hDC, RECT rc)
{
    BITMAP	bmp;
	HGDIOBJ	hOldBitmap;

    
    HDC m_hdc = CreateCompatibleDC(hDC);


    HBITMAP hbitmap = CopyPartOfImage(rc.left, rc.top, rc.right-rc.left , rc.bottom-rc.top);

	hOldBitmap = SelectObject(m_hdc, hbitmap);
	GetObject(hbitmap, sizeof(BITMAP), &bmp);


	BitBlt(hDC, rc.left, rc.top, rc.right-rc.left, rc.bottom-rc.top, m_hdc,0,0,SRCCOPY);
	

	SelectObject(hDC, hOldBitmap);

    DeleteDC(m_hdc);


    return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::DrawHotSpotIcon
//
// COMMENT: Draw a hotspot icon on the main image. 
//        
/////////////////////////////////////////////////////////////////////////////
BOOL CVOImage::DrawHotSpotIcon(HDC hdc, HOTSPOT hs)
{
	return DrawImage(hdc,hs.hRgn,hs.hBitmap,hs.crImageThresholdColor,hs.dwRemoveImageColor);
}

/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::DrawEventIcon
//
// COMMENT: Draw a event icon (this type of icon is painted when a pen 
// is pushed down on the screen) on the main image. 
//        
/////////////////////////////////////////////////////////////////////////////
BOOL CVOImage::DrawEventIcon(HDC hdc, EVENT ie)
{
    return DrawImage(hdc,ie.hRgn,ie.hBitmap,ie.crImageThresholdColor,ie.dwRemoveImageColor);
}

/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::DrawImage
//
// COMMENT: Draw a icon/image on the main image. Use a threshold value
// to decide which part of the icon/image to be painted. 
//        
/////////////////////////////////////////////////////////////////////////////
BOOL CVOImage::DrawImage(HDC hdc, HRGN hRgn, HBITMAP hBm,COLORREF crThreshold,DWORD dwRemoveImageColor)
{
	BITMAP	bmp;
	HGDIOBJ	hOldBitmap;
    HDC m_hdc;
    RECT rc;

    GetRgnBox(hRgn,&rc); 
    
    m_hdc = CreateCompatibleDC(hdc);
	
    hOldBitmap = SelectObject(m_hdc, hBm);
	GetObject(hBm, sizeof(BITMAP), &bmp);

	COLORREF crMax= RGB(255,255,255);

	// Paint the all of the image. This is the fastest way to paint an image.
	if(dwRemoveImageColor == 0) {
			BitBlt(hdc,rc.left,rc.top,bmp.bmWidth,bmp.bmHeight,m_hdc,0,0,SRCCOPY);
	// Remove a color from the image given by the color threshold 
	// crThreshold. Also a fast way to paint an image.
	} else if(dwRemoveImageColor == 1) {
			TransparentImage(hdc,rc.left,rc.top,bmp.bmWidth,bmp.bmHeight,m_hdc,0,0,bmp.bmWidth,bmp.bmHeight,crThreshold); 
	// Remove all color below a color threshold given by the color threshold crThreshold.
	// This is a slow way to paint an image.
	} else if(dwRemoveImageColor == 2) {
		for (int i = 0;i < bmp.bmWidth - 1; i++) {
			for (int j = 0; j < bmp.bmHeight - 1; j++) {
				COLORREF  pixel = GetPixel(m_hdc,i,j);
				if(pixel <= crThreshold) {
					SetPixel(hdc,i + rc.left,j + rc.top,pixel);
				}
			}
		}
	}

	// Code below is not in use because it too slow:
#if 0

	// The following code going through all of the pixels in the bitmap, and
    // check the pixel's RGB values against the RGB threshold. The program
    // will only paint those pixels that are below this threshold value.
	if(crThreshold < crMax) {
		for (int i = 0;i < bmp.bmWidth - 1; i++) {
			int EndPaint = bmp.bmHeight - 1, PaintIndex = 0;
			bool bShiftPaint = true;
			for (int j = 0; j < bmp.bmHeight - 1; j++) {
				if (bShiftPaint == true) 
					PaintIndex = j;
				else 
					PaintIndex = EndPaint--;
				
				COLORREF  pixel = GetPixel(m_hdc,i,PaintIndex);

				if(pixel <= crThreshold) {
					SetPixel(hdc,i + rc.left,PaintIndex + rc.top,pixel);
					if(bShiftPaint == true) 
						bShiftPaint = false;
				}
			}
		}

		for (i = 0;i < bmp.bmHeight - 1; i++) {
			int EndPaint = bmp.bmWidth - 1, PaintIndex = 0;
			bool bShiftPaint = true;
			for (int j = 0; j < bmp.bmWidth - 1; j++) {
				if (bShiftPaint == true) 
					PaintIndex = j;
				else 
					PaintIndex = EndPaint--;
				COLORREF  pixel = GetPixel(m_hdc,i,PaintIndex);

				if(pixel <= crThreshold) {
					SetPixel(hdc,i + rc.left,PaintIndex + rc.top,pixel);
					if(bShiftPaint == true) 
						bShiftPaint = false;
				}
			}
		}
	} else {  // More speed with this
		BitBlt(hdc,rc.left,rc.top,bmp.bmWidth,bmp.bmHeight,m_hdc,0,0,SRCCOPY);
	}

#endif

	SelectObject(hdc, hOldBitmap);
    
    DeleteDC(m_hdc);

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::GetImageDataFromFile
//
// COMMENT: Read an image from a file
//        
/////////////////////////////////////////////////////////////////////////////
DWORD CALLBACK CVOImage::GetImageDataFromFile(LPSTR szBuffer, DWORD dwBufferMax, LPARAM lParam )
{
	DWORD dwNumberOfBytesRead;

	if ( (HANDLE)lParam == INVALID_HANDLE_VALUE )
		return 0;

	ReadFile( (HANDLE)lParam, szBuffer, dwBufferMax, &dwNumberOfBytesRead, NULL );

	// Return number of bytes read
	return dwNumberOfBytesRead;
}

void CALLBACK CVOImage::ImageProgressFromFile(IImageRender *pRender, BOOL bComplete, LPARAM lParam )
{
	if( bComplete )
	{
		;// (Optional) add code here for completion processing
	}
}
/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::GetImageDataFromURL
//
// COMMENT: Read an image from an URL. Use Callback.  
//        
/////////////////////////////////////////////////////////////////////////////
DWORD CALLBACK CVOImage::GetImageDataFromURL( LPSTR szBuffer, DWORD dwBufferMax, LPARAM lParam )
{
    DWORD dwNumberOfBytesRead;
	ImageDataHandler *ImageHandler = (ImageDataHandler *)lParam;
	BOOL bReadFile= false;
	char szTemp[1000];
    
	// Read from Internet
	if (hHTTPInternetSession == NULL)
::MessageBox(NULL,L"internetsession not OK", L"Error", MB_OK);
	else
::MessageBox(NULL,L"internet session Ok", L"Error", MB_OK);

	ImageHandler->hInternetFile = (HINTERNET)InternetOpenUrl(hHTTPInternetSession, /*_T("http://169.254.254.0/webmust/Overview.gif")*/ (LPTSTR)ImageHandler->lpFileName,NULL, 0, INTERNET_FLAG_RELOAD, 0);
	if (ImageHandler->hInternetFile == NULL){
		TCHAR szDebug[256];
		wsprintf(szDebug, TEXT("Open image URL: %s failed\r\n"), (LPTSTR)ImageHandler->lpFileName);
		::MessageBox(NULL,szDebug, L"Error", MB_OK);


LPVOID lpMsg_Buf;
wchar_t wcError[256];
		FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,GetLastError(),
			0, // Default language
			(LPTSTR) &lpMsg_Buf,
			0,
			NULL 
			); 
		swprintf(wcError,L"Error open url(): %s\r\n",lpMsg_Buf);
		::MessageBox(NULL,wcError,NULL,MB_OK);
		LocalFree(lpMsg_Buf);
	}
	else{
		TCHAR szDebug[256];
		wsprintf(szDebug, TEXT("Open image URL: %s succeeded\r\n"), (LPTSTR)ImageHandler->lpFileName);
		::MessageBox(NULL,szDebug, L"Error", MB_OK);
	}
	
	if (ImageHandler->hInternetFile == NULL /*INVALID_HANDLE_VALUE*/ )
	{
		return 0;
	}
	#if defined (_DEBUG)
		TCHAR szDebug[256];
		wsprintf(szDebug, TEXT("GetImageData1:: lParam: %s\r\n"), (LPTSTR)ImageHandler->lpFileName);
		OutputDebugString(szDebug);
	#endif
	if ( ImageHandler->hInternetFile != INVALID_HANDLE_VALUE )
	{
		// graphics file
		bReadFile = InternetReadFile((HINTERNET)ImageHandler->hInternetFile, szBuffer, dwBufferMax, &dwNumberOfBytesRead);
		if (! bReadFile){
			::MessageBox(NULL, L"couldnor read the URL", L"Error", MB_OK);
				LPVOID lpMsg_Buf;
wchar_t wcError[256];
		FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,GetLastError(),
			0, // Default language
			(LPTSTR) &lpMsg_Buf,
			0,
			NULL 
			); 
		swprintf(wcError,L"Error read url(): %s\r\n",lpMsg_Buf);
		::MessageBox(NULL,wcError,NULL,MB_OK);
		LocalFree(lpMsg_Buf);

		}
		// Check if the file exsist. 
		if(sizeof(szTemp) > strlen(szBuffer)) {
			strcpy(szTemp,szBuffer);
			_strlwr(szTemp);
			if(strstr(szTemp,"<html>") && strstr(szTemp,"not found")) {
				InternetCloseHandle( (HINTERNET)ImageHandler->hInternetFile);
				ImageHandler->hInternetFile = INVALID_HANDLE_VALUE;
				return 0;
			}
		}
	} else {
		//SendMessage(g_InetHTTP.hwndHTML, DTM_IMAGEFAIL, 0, (LPARAM) ImageHandler->pdwCookie);
		if ( ImageHandler->hInternetFile != INVALID_HANDLE_VALUE ) InternetCloseHandle( (HINTERNET)ImageHandler->hInternetFile );
		ImageHandler->hInternetFile = INVALID_HANDLE_VALUE;
		return 0;
	}
   // return amount read
	TCHAR temp_bytes[50];
wsprintf(temp_bytes, TEXT( " Read %d bytes\n" ), dwNumberOfBytesRead );
::MessageBox(NULL, temp_bytes, L"info", MB_OK);
  return dwNumberOfBytesRead;
}
////////////////////////////////////////
// Read an Image-file to a buffer
////////////////////////////////////////
DWORD CVOImage::GetImageFromFile2Buffer(LPSTR szBuffer, DWORD dwBufferMax, LPTSTR filename)
{

	
	char filename_c[512];

    //Widechartomultibyte filename
/*
	WideCharToMultiByte(CP_ACP,
		WC_COMPOSITECHECK,
		filename,
		wcslen(filename),
		filename_c,
		wcslen(filename),
		NULL,
		NULL);
*/

	
	int feil = wcstombs(&filename_c[0], filename, 1+wcslen(filename));
	
	if(feil<1)
	{MessageBox(NULL, L"Feil i wcstoms", L"Error", MB_OK);
	}

	//int feil = GetLastError();
	
	//char filepath[512];

	//strcat(filepath, "\\Temp\\" );
	//strcat(filepath, filename_c);
 

	FILE *file_id = fopen(filename_c, "r+b");
	
	long cnt=0;

	while( EOF != fgetc(file_id)){
		cnt++;
	}


	fseek(file_id, 0,SEEK_SET);

	fread(szBuffer,cnt,sizeof(char),file_id);
	fclose(filename_c);
	//return szBuffer;
	return cnt;

}

////////////////////////////////////////////
// Read a image-URL to a buffer
///////////////////////////////////////////

DWORD CVOImage::GetImageFromURL2Buffer( LPSTR szBuffer, DWORD dwBufferMax, ImageDataHandler *ImageHandler )
{
	DWORD dwNumberOfBytesRead;
	//ImageDataHandler *ImageHandler = (ImageDataHandler *)lParam;
	BOOL bReadFile= false;
	char szTemp[1000];

	// Read from Internet
	if (hHTTPInternetSession == NULL)
		::MessageBox(NULL,L"internetsession not OK", L"Error", MB_OK);
	//else
	//	::MessageBox(NULL,L"internet session Ok", L"Error", MB_OK);



	
	
	

	ImageHandler->hInternetFile = (HINTERNET)InternetOpenUrl(hHTTPInternetSession, /*_T("http://169.254.254.0/webmust/Overview.gif")*/ (LPTSTR)ImageHandler->lpFileName,NULL, 0, INTERNET_FLAG_RELOAD, 0);
	
	//TCHAR szDebug1[256];
	//wsprintf(szDebug1, (LPTSTR) filnavn, (LPTSTR)ImageHandler->lpFileName);
	//OutputDebugString(szDebug1);
	if (ImageHandler->hInternetFile == NULL){
		TCHAR szDebug[256];
		wsprintf(szDebug, TEXT("Open image URL: %s failed\r\n"), (LPTSTR)ImageHandler->lpFileName);
		::MessageBox(NULL,szDebug, L"Error", MB_OK);


		LPVOID lpMsg_Buf;
		wchar_t wcError[256];
		FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,GetLastError(),
			0, // Default language
			(LPTSTR) &lpMsg_Buf,
			0,
			NULL 
			); 
		swprintf(wcError,L"Error open url(): %s\r\n",lpMsg_Buf);
		::MessageBox(NULL,wcError,NULL,MB_OK);
		LocalFree(lpMsg_Buf);
	}
	/*else{
	TCHAR szDebug[256];
	wsprintf(szDebug, TEXT("Open image URL: %s succeeded\r\n"), (LPTSTR)ImageHandler->lpFileName);
	::MessageBox(NULL,szDebug, L"Error", MB_OK);
	}*/

	if (ImageHandler->hInternetFile == NULL /*INVALID_HANDLE_VALUE*/ )
	{
		return 0;
	}
#if defined (_DEBUG)
	TCHAR szDebug[256];
	wsprintf(szDebug, TEXT("GetImageData2:: lParam: %s\r\n"), (LPTSTR)ImageHandler->lpFileName);
	OutputDebugString(szDebug);

	
#endif
	if ( ImageHandler->hInternetFile != NULL )
	{
		// graphics file
		bReadFile = InternetReadFile((HINTERNET)ImageHandler->hInternetFile, szBuffer, dwBufferMax, &dwNumberOfBytesRead);
		if (! bReadFile){
			::MessageBox(NULL, L"couldnor read the URL", L"Error", MB_OK);
			LPVOID lpMsg_Buf;
			wchar_t wcError[256];
			FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | 
				FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL,GetLastError(),
				0, // Default language
				(LPTSTR) &lpMsg_Buf,
				0,
				NULL 
				); 
			swprintf(wcError,L"Error read url(): %s\r\n",lpMsg_Buf);
			::MessageBox(NULL,wcError,NULL,MB_OK);
			LocalFree(lpMsg_Buf);
            return 0;
		}
		// Check if the file exsist. 
		if(sizeof(szTemp) > strlen(szBuffer)) {
			strcpy(szTemp,szBuffer);
			_strlwr(szTemp);
			if(strstr(szTemp,"<html>") && strstr(szTemp,"not found")) {
				InternetCloseHandle( (HINTERNET)ImageHandler->hInternetFile);
				ImageHandler->hInternetFile = INVALID_HANDLE_VALUE;
				return 0;
			}
		}
	} else {
		//SendMessage(g_InetHTTP.hwndHTML, DTM_IMAGEFAIL, 0, (LPARAM) ImageHandler->pdwCookie);
		if ( ImageHandler->hInternetFile != INVALID_HANDLE_VALUE ) InternetCloseHandle( (HINTERNET)ImageHandler->hInternetFile );
		ImageHandler->hInternetFile = INVALID_HANDLE_VALUE;
		return 0;
	}
	// return amount read
	/*TCHAR temp_bytes[50];
	wsprintf(temp_bytes, TEXT( " Read %d bytes\n" ), dwNumberOfBytesRead );
	::MessageBox(NULL, temp_bytes, L"info", MB_OK);*/
	return dwNumberOfBytesRead;
}

/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::ReadImageDataFromURL
//
// COMMENT: Read an image from an URL  
//        
/////////////////////////////////////////////////////////////////////////////

DWORD CVOImage::ReadImageDataFromURL(BYTE * szBuffer, DWORD dwBufferMax, LPCTSTR lpFileName)
{
	DWORD dwNumberOfBytesRead;
	HINTERNET hInternetFile;
	BOOL bReadFile = false;

	hInternetFile = (HINTERNET)InternetOpenUrl(hHTTPInternetSession, (LPTSTR)lpFileName,NULL, 0, INTERNET_FLAG_RELOAD | INTERNET_FLAG_DONT_CACHE, 0);
	if (hInternetFile == NULL){
		TCHAR szDebug[256];
		wsprintf(szDebug, TEXT("Open image URL: %s failed\r\n"), (LPTSTR)lpFileName);
		::MessageBox(NULL,szDebug, L"Error", MB_OK);
	}
	else{
		TCHAR szDebug[256];
		wsprintf(szDebug, TEXT("Open image URL: %s succeeded\r\n"), (LPTSTR)lpFileName);
		::MessageBox(NULL,szDebug, L"Error", MB_OK);
	}
		
	if (hInternetFile == INVALID_HANDLE_VALUE ){
		return 0;
	}
	#if defined (_DEBUG)
		TCHAR szDebug[256];
		wsprintf(szDebug, TEXT("Get image data: %s\r\n"), (LPTSTR)lpFileName);
		OutputDebugString(szDebug);
	#endif
	if ( hInternetFile != INVALID_HANDLE_VALUE )
	{
		bReadFile = InternetReadFile(hInternetFile, szBuffer, dwBufferMax, &dwNumberOfBytesRead);
	} else {
		if ( hInternetFile != INVALID_HANDLE_VALUE ) InternetCloseHandle( hInternetFile );
		return 0;
	}
   // return amount read
  return dwNumberOfBytesRead;
}

/////////////////////////////////////////////////////////////////////////////
// METHOD: CVOImage::ImageProgressFromURL
//
// COMMENT: Get progress information about the downloading of a file from
// a URL. Get also a handler to the converted image.
//        
/////////////////////////////////////////////////////////////////////////////
void CALLBACK CVOImage::ImageProgressFromURL( IImageRender *pRender, BOOL bComplete, LPARAM lParam )
{

	::MessageBox(NULL, L"imageprogress called", L"Error", MB_OK);
	
	ImageDataHandler *ImageHandler = ( ImageDataHandler * )lParam;

  if( bComplete )
	{
    iii.dwCookie = ( WPARAM )ImageHandler->pdwCookie;

	pRender->GetBitmap(&iii.hbm, TRUE);
    pRender->GetOrigHeight(&iii.iOrigHeight);
    pRender->GetOrigWidth(&iii.iOrigWidth);

    // Take ownership of the hBitmap
    iii.bOwnBitmap  = TRUE;
    if ( iii.hbm )
    {
//			SendMessage(g_InetHTTP.hwndHTML, DTM_SETIMAGE, 0, LPARAM( &iii ));
    }
#if defined (_DEBUG)
	    TCHAR szDebug[256];
		wsprintf(szDebug, TEXT("ImageComplete: %s\r\n"), (LPTSTR)ImageHandler->lpFileName);
		OutputDebugString(szDebug);
#endif
	InternetCloseHandle((HINTERNET)ImageHandler->hInternetFile);
  }
}


DWORD CALLBACK CVOImage::GetImageResourceData(LPSTR szBuffer, DWORD dwBufferMax, LPARAM lParam)
{
	DWORD			dwNumberOfBytesToRead = dwBufferMax;
	CVOResource*	pRes = (CVOResource*) lParam;

	if(!pRes)
		return 0;

	DWORD			dwResourceOffset = pRes->GetUserData();

	if(dwResourceOffset + dwNumberOfBytesToRead > pRes->GetSize() )
		dwNumberOfBytesToRead = pRes->GetSize() - dwResourceOffset;

	memmove(szBuffer, pRes->GetData() + dwResourceOffset, dwNumberOfBytesToRead);

	pRes->SetUserData(dwResourceOffset + dwNumberOfBytesToRead);
	return dwNumberOfBytesToRead;	// return amount read
}

void CALLBACK CVOImage::ImageProgress(IImageRender *pRender, BOOL bComplete, LPARAM lParam )
{
	if( bComplete )
	{
		;// (Optional) add code here for completion processing
	}
}


DWORD CVOImage::GetHeight()
{
	return m_dwHeight;
}

DWORD CVOImage::GetWidth()
{
	return m_dwWidth;
}

BOOL CVOImage::SetBitmap(HDC hdc, DWORD dwResourceID, LPCTSTR pcszClass, HMODULE hModule)
{
	if(!g_hdc)
		g_hdc = CreateCompatibleDC(hdc);


	BYTE    szBuffer[1024] = {0}; 
	

	CVOResource	res(hModule, dwResourceID, pcszClass);

	if(!res.IsLoaded())
		return FALSE;

	res.SetUserData(0);	// Use this for the current resource offset

#ifdef _WIN_CE
    HRESULT hr;
    DecompressImageInfo	dii;

	// Fill in the 'DecompressImageInfo' structure
	dii.dwSize = sizeof( DecompressImageInfo );		// Size of this structure
	dii.pbBuffer = szBuffer;						// Pointer to the buffer to use for data
	dii.dwBufferMax = 1024;							// Size of the buffer
	dii.dwBufferCurrent = 0;						// The amount of data which is current in the buffer
	dii.phBM = &m_hbitmap;							// Pointer to the bitmap returned (can be NULL)
	dii.ppImageRender = NULL;						// Pointer to an IImageRender object (can be NULL)
	dii.iBitDepth = GetDeviceCaps(hdc,BITSPIXEL);	// Bit depth of the output image
	dii.lParam = ( LPARAM ) &res;					// User parameter for callback functions
	dii.hdc = g_hdc;								// HDC to use for retrieving palettes
	dii.iScale = g_iScale;							// Scale factor (1 - 100)
	dii.iMaxWidth = g_iMaxWidth;					// Maximum width of the output image
	dii.iMaxHeight = g_iMaxHeight;					// Maxumum height of the output image
	dii.pfnGetData = GetImageResourceData;			// Callback function to get image data
	dii.pfnImageProgress = ImageProgress;			// Callback function to notify caller of progress decoding the image
	dii.crTransparentOverride = ( UINT ) -1;		// If this color is not (UINT)-1, it will override the
																								// transparent color in the image with this color. (GIF ONLY)
	// Process and decompress the image data
	hr = DecompressImageIndirect( &dii );
#else
   
#endif
		
	BITMAP	bmp;

	GetObject(m_hbitmap, sizeof(BITMAP), &bmp);

	m_dwWidth = bmp.bmWidth;
	m_dwHeight = bmp.bmHeight;

	return TRUE;
}
BOOL CVOImage::IsLoaded()
{
	return (m_hbitmap != 0);
}

CVOResource::CVOResource(HMODULE hModule, DWORD dwResourceID, LPCTSTR pcszClass)
{
	m_dwSize = 0;
	m_hGlobal = 0;
	m_pData = 0;

	m_hrsrc = FindResource(hModule, (LPCWSTR)dwResourceID, pcszClass);

	if(m_hrsrc == 0)
		return;

	m_dwSize = SizeofResource(hModule, m_hrsrc);
	m_hGlobal = LoadResource(hModule, m_hrsrc);
	m_pData = (PBYTE) LockResource(m_hGlobal);
}

CVOResource::~CVOResource()
{
	if(m_hGlobal)
		DeleteObject(m_hGlobal);
}

BOOL CVOResource::IsLoaded()
{
	return (m_pData != NULL);
}
