#if !defined(AFX_VOIMAGE_H__B83C4202_DB1E_48BE_92A5_21019F9EE6FC__INCLUDED_)
#define AFX_VOIMAGE_H__B83C4202_DB1E_48BE_92A5_21019F9EE6FC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#ifndef SPCollec_h
#include "spcollec.h" // For linked list
#endif
#include "imgdecmp.h"
#include "Commdlg.h"
#include <wininet.h>
#include <imaging.h>
//#include <afxwin.h>

#ifndef UNDER_CE

#include <math.h>
#include <olectl.h>
#include <ocidl.h>
#include <atlbase.h>

#endif


#include "tools.h"

#define  MAX_STRING_SIZE 1024

// Contains information
// about a decompressed image:
typedef struct tagINLINEIMAGEINFO
{
    DWORD       dwCookie;
    int         iOrigHeight;
    int         iOrigWidth;
    HBITMAP     hbm;
    BOOL        bOwnBitmap;
} INLINEIMAGEINFO, *LPINLINEIMAGEINFO;


// Contains information
// about an internet file:
typedef struct tagImageDataHandler
{
	LPVOID lpFileName;
	LPVOID pdwCookie;
	HINTERNET hInternetFile;
} ImageDataHandler;


// Contains information about
// a font:
typedef struct {
    COLORREF crTextColor;
    COLORREF crTextBkColor;
    TCHAR szFontType[256];
    BOOL bUnderLine;
    BOOL bTransparent;
    BOOL bItalic;  
    DWORD dwFontSize;  
} FONT, *PFONT;

// Contains information
// about painted -, text - (also pained) and image hotspots:

typedef struct HOTSPOT {
    HRGN hRgn;
    HBITMAP hBitmap;
	BOOL bFiller;
	BOOL bBorder;
	BOOL bTransparentHotspotEvent;
	DWORD dwPenWidth;
	DWORD dwBorderWidth;
	DWORD dwRemoveImageColor;
    COLORREF crBorderColor; 
    COLORREF crFillerColor;
    COLORREF crImageThresholdColor;
    TCHAR szMouseText[256];
    TCHAR szEventText[256];
    TCHAR szShapeType[50];
	TCHAR szText[256];
    FONT font;

} * PHOTSPOT;

// Use template for a linked list of hotspots
typedef CSPList<HOTSPOT,HOTSPOT&> HOTSPOTLIST;

// Contains information
// about painted -, text - (also pained) and image events:
// The events are connected to the hotspot through an identity
// text in the string szEventText.


typedef struct {
    HRGN hRgn;
    HBITMAP hBitmap;
	BOOL bFiller;
	BOOL bBorder;
	DWORD dwBorderWidth;
	DWORD dwPenWidth;
	DWORD dwRemoveImageColor;
	COLORREF crEventBorderColor;
	COLORREF crEventFillerColor;  
    COLORREF crImageThresholdColor;
    TCHAR szEventText[256];
	TCHAR szShapeType[50];
	TCHAR szText[256];
	FONT font;
} EVENT, *PEVENT;

// Use template for a liked list of event images
typedef CSPList<EVENT,EVENT&> EVENTLIST;

// Contains information windows controls (edit box, combo box
// and button):

typedef struct {
    HWND hWnd;
    TCHAR szEventText[256];
	TCHAR szSubmitText[256];
} CONTROL, *PCONTROL;

// Use template for a linked list of controls
typedef CSPList<CONTROL,CONTROL&> CONTROLLIST;


class CVOResource
{
public:
	CVOResource(HMODULE hModule, DWORD dwResourceID, LPCTSTR pcszClass);
	~CVOResource();

	BOOL IsLoaded();

	DWORD	GetSize()	{ return m_dwSize; }
	PBYTE	GetData()	{ return m_pData; }

	void	SetUserData(DWORD dwValue)	{ m_dwUser = dwValue; }
	DWORD	GetUserData()				{ return m_dwUser; }

/*protected:*/
public:
	DWORD m_dwUser;

	DWORD m_dwSize;
	PBYTE m_pData;
	HGLOBAL m_hGlobal;
	HRSRC m_hrsrc;
};

class CVOImage  
{
public:
	HBITMAP Copy();
	HBITMAP CopyPartOfImage(int nXDest, int nYDest,int nWidth,int nHeight);
    HBITMAP LoadHotSpotImageFile(HINSTANCE hIns,HDC hdc, LPCTSTR pcszFileName,LPCTSTR pszLocalPathName);
	HBITMAP LoadImageWithImagingApi(VOID* szBuffer, DWORD dwBufferMax,ImageDataHandler *ihandler);//(LPCTSTR strFileName);
	DWORD GetImageFromURL2Buffer( LPSTR szBuffer, DWORD dwBufferMax, ImageDataHandler *ImageHandler );
    DWORD GetImageFromFile2Buffer(LPSTR szBuffer, DWORD dwBufferMax, LPTSTR filename);
	BOOL PaintRectangle(HDC hDC, HRGN hRgn);
	BOOL PaintEllipse(HDC hDC, HRGN hRgn);
    BOOL PaintHotSpot(HDC hDC, HOTSPOT hs);
	BOOL PaintEvent(HDC hDC, EVENT ev);
	BOOL PaintItem(HDC hDC,HRGN hRgn, FONT font, PTCHAR szShapeType, PTCHAR szText, COLORREF crFillerColor, COLORREF crBorderColor, BOOL bFiller, BOOL bBorder,DWORD dwBorderWidth, DWORD dwPenWidth);
	static DWORD CALLBACK GetImageResourceData(LPSTR szBuffer, DWORD dwBufferMax, LPARAM lParam);
	BOOL IsLoaded();
	static void CALLBACK ImageProgressFromFile( IImageRender *, BOOL, LPARAM);
	static void CALLBACK ImageProgressFromURL( IImageRender *, BOOL, LPARAM);
	static DWORD CALLBACK GetImageDataFromFile( LPSTR, DWORD, LPARAM);
	static DWORD CALLBACK GetImageDataFromURL( LPSTR, DWORD, LPARAM);
	DWORD ReadImageDataFromURL(BYTE * szBuffer, DWORD dwBufferMax, LPCTSTR lpFileName);
	static void CALLBACK ImageProgress( IImageRender *, BOOL, LPARAM);
	BOOL SetBitmap(HDC hdc, DWORD dwResourceID, LPCTSTR pcszClass = TEXT("IMAGE"), HMODULE hModule = 0 );
	DWORD GetWidth();
	DWORD GetHeight();
	BOOL Draw(HDC hdc, int x, int y, int cx = -1, int cy = -1);
    BOOL DrawHotSpotIcon(HDC hdc,HOTSPOT hs);
    BOOL DrawEventIcon(HDC hdc,EVENT ie);
    BOOL DrawImage(HDC hdc, HRGN hRgn, HBITMAP hBm,COLORREF crThreshold,DWORD dwRemoveImageColor);
    BOOL DrawPartOfImage(HDC hDC, RECT rc);
	BOOL LoadBkImage(HINSTANCE hIns,HDC hdc, LPCTSTR pcszFileName,LPCTSTR pcszLocalPathName);
    BOOL LoadFromUrl(HINSTANCE hIns,HDC hdc, LPCTSTR pcszFileName, LPCTSTR pcszLocalPathName);
    HBITMAP LoadCompressedImage(HINSTANCE hIns,HDC hdc,LPCTSTR pcszFileName, LPCTSTR pszLocalPathName);
	CVOImage();
	virtual ~CVOImage();


	operator HBITMAP() { return m_hbitmap; }

/*protected:*/
public:
	DWORD		m_dwHeight;
	DWORD		m_dwWidth;
	HBITMAP		m_hbitmap;
	HRGN        m_hRgn;
	static BOOL g_bStretchBlt;
	static int	g_iMaxHeight;
	static int	g_iMaxWidth;
	static int	g_iScale;
	static HDC	g_hdc;
#ifndef UNDER_CE
	LPPICTURE spIPicture[100];
	DWORD g_dwPictureCount;
#endif
	
};

#endif // !defined(AFX_VOIMAGE_H__B83C4202_DB1E_48BE_92A5_21019F9EE6FC__INCLUDED_)
