// mapview.cpp : Implementation of Cmapview




#include "stdafx.h"

#include "Mapctrl.h"
#include "mapview.h"
#include "Winuser.h" 

// jek
static int nRaiseKeyboardOnFocusGlobal = 0;

// jek
static 	WCHAR szValues[MAX_INDEX_COMBOBOXITEM][MAX_CARACTERS_COMBOBOXITEM];

static  WCHAR send_param[150];
 
/////////////////////////////////////////////////////////////////////////////
// Cmapview

Cmapview::Cmapview() {

	// Debug handler
    m_hWndDebug = NULL; 

    // Begin control attrib
    bLBDown = FALSE; 
    m_PenWidth = 1; // Standard pen width
	m_dwCurrentSafety = INTERFACESAFE_FOR_UNTRUSTED_CALLER // ActiveX security option
                          | INTERFACESAFE_FOR_UNTRUSTED_DATA;
	m_pszItems = NULL;
	m_dwParamCnt = 0;
	m_hWndCtrl = NULL;
    m_bSetFocus = FALSE; 
	m_hf = NULL;
    // End control attrib

    // Begin paint attrib
    m_crBorderColor = RGB(0,0,0);
    m_crFillerColor = RGB(0,0,0); 
    m_crEventBorderColor = RGB(0,0,0);
    m_crEventFillerColor = RGB(0,0,0); 
    m_crTextColor = RGB(0,0,0);
    m_crImageThresholdColor = RGB(0,0,0);
    m_crTextBkColor = RGB(0,0,0);

    m_rectMouseText.left = 0;
    m_rectMouseText.top = 0;
    m_rectMouseText.right = 0;
    m_rectMouseText.bottom = 0;

	m_dwPenWidth = 1;
	m_dwRemoveImageColor = 0;
	m_bTransparentHotspotEvent = false;
  
    // Begin font attrib
	m_bUnderline = FALSE;
    m_bItalic = FALSE;
    m_bTransparent = TRUE;
    m_dwFontSize = 10;
    wcscpy(m_szFontType,L"Arial");
	// End font attrib

    m_pImage = NULL;
	
    m_dwMouseXPos=0, m_dwMouseYPos=0;
	m_dwCursorOffsetX = 3, m_dwCursorOffsetY = 10;
	m_ImageOffsetX = 0, m_ImageOffsetY = 40;
	
    m_bInfoIsPainted = FALSE;
	m_bRepaintPicture = TRUE;
    m_dwHotSpotCounter = 0;
    m_dwEventCounter = 0;

    m_dwControlCounter = 0;

    // End paint attrib
//::MessageBox(NULL, L"Activex control created", L"Error", MB_OK);
}

Cmapview::~Cmapview()
{

    if (m_pszItems) delete m_pszItems;
	if (m_hWndCtrl) ::DestroyWindow(m_hWndCtrl);
    if(m_hWndDebug) ::DestroyWindow(m_hWndDebug);
	
	// Remove images and regions from the event list
	SPLISTPOS ListPosEvent =  m_EventList.GetHeadPosition();
    
	while (ListPosEvent) {
        EVENT& ev = m_EventList.GetNext(ListPosEvent);
		// Close the window handle
		if(ev.hBitmap) 
			DeleteObject(ev.hBitmap);
		if(ev.hRgn)
			DeleteObject(ev.hBitmap);
	}
    // Remove image events from the image event linked list
    m_EventList.RemoveAll();

	// Remove images and regions from the event list
	SPLISTPOS ListPosHotspot =  m_HotSpotList.GetHeadPosition();
    while (ListPosHotspot) {
        HOTSPOT& hs = m_HotSpotList.GetNext(ListPosHotspot);
		// Close the window handle
		if(hs.hBitmap) 
			DeleteObject(hs.hBitmap);
		if(hs.hRgn)
			DeleteObject(hs.hBitmap);
	}
    // Remove hotspot elements from the list
    m_HotSpotList.RemoveAll(); 
    // Remove control elements from the control linked list
	SPLISTPOS ListPosControl =  m_ControlList.GetHeadPosition();
    while (ListPosControl) {
        CONTROL& hs = m_ControlList.GetNext(ListPosControl);
		// Close the window handle
		if(hs.hWnd) {
			::DestroyWindow(hs.hWnd);
			hs.hWnd = NULL;
		}
	}
	m_ControlList.RemoveAll();

}


DWORD Cmapview::_GetMiscStatus(){
	return 0;
}
/////////////////////////////////////////////////////////////////////////////
// METHOD: Cmapview::RepaintAll
//
// COMMENT: Repaint background image and hotspots (painted or icon)
//        
/////////////////////////////////////////////////////////////////////////////
void Cmapview::RepaintAll() {

    HDC hDC = GetDC();    

    // Draw main image
    m_pImage->Draw(hDC,0,0,-1,-1);

    // Paints hotspots on the background image
    SPLISTPOS ListPos =  m_HotSpotList.GetHeadPosition();
    while (ListPos) {
        HOTSPOT& hs = m_HotSpotList.GetNext( ListPos );
		if(hs.hRgn) {
            if(hs.hBitmap != NULL) {
               m_pImage->DrawHotSpotIcon(hDC,hs);
            } else {
				if(wcslen(hs.szShapeType))
					m_pImage->PaintHotSpot(hDC,hs);
            }
		}
	}
    ReleaseDC(hDC);

}


/////////////////////////////////////////////////////////////////////////////
// METHOD: Cmapview::OnDraw
//
// COMMENT: Paint main image and hotspots (painted or icon) or a text.
// The text is only painted if the control only contain the static text.
//
/////////////////////////////////////////////////////////////////////////////
HRESULT Cmapview ::OnDraw(ATL_DRAWINFO & di)
{
    RECT rc = *((RECT*)di.prcBounds);
    HDC  hDC  = di.hdcDraw;

    // Paint background image and hotspots
    if(m_pImage)  RepaintAll();
    
	// Paint static text
	if(!_wcsnicmp(m_szInputText,L"STATIC",wcslen(L"STATIC"))) {
        HFONT hf;
        // Create font
        LOGFONT lf = CreateLogFont(rc.bottom, 0, 0, 0, 400, m_bItalic, m_bUnderline,      
            0, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
            DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, m_szFontType);

 
        hf = (HFONT) SelectObject(hDC,CreateFontIndirect(&lf));

			
		// Paint the background color and the font color
		SetBkColor(hDC,m_crTextBkColor);
		SetTextColor(hDC,m_crTextColor);

		// Paint the text
		DrawText(hDC,m_szStaticText,wcslen(m_szStaticText),&rc,DT_SINGLELINE | DT_VCENTER | DT_CENTER);
		DeleteObject(SelectObject(hDC,hf));

	} 


    ReleaseDC(hDC);


    return S_OK;
}


/////////////////////////////////////////////////////////////////////////////
// METHOD: Cmapview::OnLButtonDown
// 
// COMMENT: Left mouse button down (same as if a pen is pushed down 
// on a PDA screen) generate a hotspot event if the mouse/pen is inside
// a hotspot. 
// If the hotspot contains an event text this text is sent to the
// main threads message loop. If there exist any painted/Icon 
// events connected to the hotspot they are painted.
// 
/////////////////////////////////////////////////////////////////////////////
LRESULT Cmapview ::OnLButtonDown(UINT    uMsg,    
								 WPARAM  wParam,
								 LPARAM  lParam,
								 BOOL &  bHandled) {

	HDC hDC = GetDC();
	
	int xPos = LOWORD(lParam), yPos = HIWORD(lParam);
      
    SPLISTPOS ListPos =  m_HotSpotList.GetHeadPosition();
    while (ListPos) {
         HOTSPOT& hs = m_HotSpotList.GetNext( ListPos );
		 // Check if the mouse/pen position is inside a hotspot region. 
         if (PtInRegion(hs.hRgn,xPos,yPos)) {
			// Using the following region handle in the Cmapview::OnLButtonUp 
			// event to send notification back to the server program only if
			// the mouse is inside the same region as this hotspot.
		    
			m_hRgn = hs.hRgn;

            // Paint any image/shape (rectangle or ellipse) /text connected to the hotspot
            SPLISTPOS ListPosInner =  m_EventList.GetHeadPosition();
            while (ListPosInner) {
                EVENT& ie = m_EventList.GetNext(ListPosInner);
                if(!_wcsicmp(hs.szEventText,ie.szEventText)) {
					if(ie.hBitmap != NULL)
						m_pImage->DrawEventIcon(hDC,ie);
					else
						m_pImage->PaintEvent(hDC,ie);
                }
            }
			// Break the loop if the transparent hotspot event is set
			// to false.
			if(hs.bTransparentHotspotEvent == false) {
				ListPos = NULL;
			}
         }
    }

    // Set focus on the main window
    SetFocus(); 
			
	// Static text. This text is only painted when the activex
	// contol only contains this text.
	if(!_wcsnicmp(m_szInputText,L"STATIC",wcslen(L"STATIC"))) {
		DWORD dwID = GetCurrentThreadId();
		::PostThreadMessage(dwID,WM_COMMAND,(WPARAM)L"EVENTDATA",(LPARAM)m_szStaticTextID);
	} else if(!_wcsnicmp(m_szInputText,L"IMAGE",wcslen(L"IMAGE"))) {

	}

    ReleaseDC(hDC);

    bHandled = TRUE;
    return 0;
}

/////////////////////////////////////////////////////////////////////////////
// METHOD: Cmapview::OnLButtonUp
// 
// COMMENT: Left mouse button up generate a hotspot event if the mouse/pen was 
// inside a hotspot. The painted/icon events connected to the left mouse
// button down are removed. The hotspots are repaited. 
// 
/////////////////////////////////////////////////////////////////////////////
LRESULT Cmapview ::OnLButtonUp(UINT    uMsg,    
							   WPARAM  wParam,    
							   LPARAM  lParam,    
							   BOOL &  bHandled) {

    HDC hDC = GetDC();
	RECT rco;
	
	int xPos = LOWORD(lParam), yPos = HIWORD(lParam);

     SPLISTPOS ListPos =  m_HotSpotList.GetHeadPosition();
	 while (ListPos) {
         HOTSPOT& hs = m_HotSpotList.GetNext( ListPos );
		 // Check if the mouse/pen was inside a hotspot
		 GetRgnBox(hs.hRgn,&rco);
		 if (PtInRegion(hs.hRgn,xPos,yPos)) {

			 if(hs.hRgn == m_hRgn) {
				DWORD dwID = GetCurrentThreadId();
				OUTPUT_TEXT(hs.szEventText);

				//NDW
				//WCHAR send_param[150];
				int tmp_pos;
				tmp_pos=swprintf(&send_param[0],hs.szEventText);
				tmp_pos=swprintf(&send_param[tmp_pos],L"\t%d\t%d",xPos,yPos);
				
				// Send event text to the threads main message loop
				::PostThreadMessage(dwID,WM_COMMAND,(WPARAM)L"EVENTDATA",(LPARAM)send_param /*hs.szEventText*/);
			 }
             SPLISTPOS ListPosInner =  m_EventList.GetHeadPosition();
			 while (ListPosInner) {
				 EVENT& ie = m_EventList.GetNext( ListPosInner );
				 if(!_wcsicmp(hs.szEventText,ie.szEventText)) {
					 // Remove painted/icon event
					 RECT rc;
					 GetRgnBox(ie.hRgn,&rc);
					 RemoveDisplay(hDC,rc);
				 }
			 }
			 // Repaint hotspots
			 if(hs.hBitmap != NULL) {
				m_pImage->DrawHotSpotIcon(hDC,hs);
			 } else {
				 if(wcslen(hs.szShapeType))
					m_pImage->PaintHotSpot(hDC,hs);
			 }
                
		 }
	}
	// Kill the timer event connected to the mouse text, so
	// no mouse text is painted.
	KillTimer(PAINT_TIMER_ID);

	// Repaint that part of the main image where the mouse
	// text is.
    if(m_bInfoIsPainted)  {
        m_pImage->DrawPartOfImage(hDC,m_rectMouseText);
        RemoveDisplay(hDC,m_rectMouseText);
        m_bInfoIsPainted = false;
    }
	
    bHandled = TRUE;

    return 0;
}

/////////////////////////////////////////////////////////////////////////////
// METHOD: Cmapview ::OnMouseMove
// 
// COMMENT: To get the mouse move work on the PDA the pen need to be on
// the screen when it moves. Use a timer to create a text that pop up
// when the pen/mouse move over a hotspot.
/////////////////////////////////////////////////////////////////////////////
LRESULT Cmapview::OnMouseMove
(
    UINT    uMsg,
    WPARAM  wParam,
    LPARAM  lParam,
    BOOL &  bHandled
)
{

    HDC hdc = GetDC(); 
	RECT rect,rectMain;
	GetClientRect(&rectMain);
	BOOL bCursorInHotSpot = false;
	DWORD dwXPos = LOWORD(lParam), dwYPos = HIWORD(lParam);
    SPLISTPOS ListPos =  m_HotSpotList.GetHeadPosition();
	 while (ListPos) {
         HOTSPOT& hs = m_HotSpotList.GetNext( ListPos );
		if(hs.hRgn) {
			// Ckeck if the mouse/pen is inside a hotspot
	        if (PtInRegion(hs.hRgn,dwXPos,dwYPos)) {
		        // Send a timer message for painting the mouse text,
		        // if this text isn't already painted.
		        SetCursor(LoadCursor(NULL,IDC_UPARROW));
		        GetRgnBox(hs.hRgn,&rect); 
		        m_dwMouseXPos = dwXPos;m_dwMouseYPos = dwYPos;
		        DWORD dwSecond = 1;
		        DWORD dwTextLenght = wcslen(hs.szMouseText);
		        if (!m_bInfoIsPainted && dwTextLenght) 
			        SetTimer(PAINT_TIMER_ID,dwSecond * 1);
		        bCursorInHotSpot = true;



				if ( (hs.szMouseText[0] == 'b') &&
					 (hs.szMouseText[1] == 'a') && 
					 (hs.szMouseText[2] == 'c') &&
					 (hs.szMouseText[3] == 'k') && 
					 (hs.szMouseText[4] == 'g') &&
					 (hs.szMouseText[5] == 'r') &&
					 (hs.szMouseText[6] == 'o') &&
					 (hs.szMouseText[7] == 'u') &&
					 (hs.szMouseText[8] == 'n') &&
					 (hs.szMouseText[9] == 'd') 	) { 
																													
					bCursorInHotSpot = false;
				
				}

		        break;
	        } 
        }
	}
	// If the mouse/pen move outside the hotspot kill
	// the mouse text timer
	if (!bCursorInHotSpot) {
		KillTimer(PAINT_TIMER_ID);
		// Repaint that part of the image that contains
		// the mouse text
        if(m_bInfoIsPainted)  {
             m_pImage->DrawPartOfImage(hdc,m_rectMouseText);
             RemoveDisplay(hdc,m_rectMouseText);
        }
		m_bInfoIsPainted = false;
	}

	ReleaseDC(hdc);


    bHandled = TRUE;


    return 0;
}

/////////////////////////////////////////////////////////////////////////////
// METHOD: Cmapview::RemoveDisplay
// 
// COMMENT: Remove icon/painted events and mouse text from the main image.
/////////////////////////////////////////////////////////////////////////////
void  Cmapview::RemoveDisplay(HDC hdc,RECT rc)
{

	// Draw part of the main image
	rc.bottom+=1;
	rc.left-=1;
	rc.right+=1;
	rc.top-=1;
    m_pImage->DrawPartOfImage(hdc,rc);
    
    // Check if the mouse text is inside any hotspot, if so repaint
    // the hotspot
    SPLISTPOS ListPos =  m_HotSpotList.GetHeadPosition();
    while (ListPos) {
        HOTSPOT& hs = m_HotSpotList.GetNext( ListPos );
        if(hs.hRgn) {
            HRGN hRegMouse = NULL;
            if(!(hRegMouse=CreateRectRgnIndirect(&rc)) ) {
                 OUTPUT_TEXT(L"NULLREGION");
            }
            HRGN hRegDest = CreateRectRgn(1,1,2,2);
            int Result = CombineRgn(hRegDest, hRegMouse, hs.hRgn,RGN_AND);
            if (Result == SIMPLEREGION) {
                 if(hs.hBitmap != NULL) {
                    m_pImage->DrawHotSpotIcon(hdc,hs);
                 } else {
					 if(wcslen(hs.szShapeType))
						m_pImage->PaintHotSpot(hdc,hs);
                 }
            }
		}
    }

}

/////////////////////////////////////////////////////////////////////////////
// METHOD: Cmapview ::OnCtrl
//
// COMMENT: WM_COMMAND messages. Get notification message from the control.
//          The event text from any edit box, combo box or button is
//          sent to the thread's main message loop.
/////////////////////////////////////////////////////////////////////////////

LRESULT Cmapview ::OnCtrl
(
    UINT    uMsg,
    WPARAM  wParam,
    LPARAM  lParam,
    BOOL &  bHandled
)
{
	WCHAR szItem[256];
	DWORD dwID = GetCurrentThreadId();
	UINT nID = LOWORD(wParam);
	UINT nID_N = HIWORD(wParam);


	switch(nID)	
	{   // Button message
		case IDC_BUTTON:
			{
				WCHAR szSubmit[256] = {0};
				WCHAR szTemp[3000] = {0};
				WCHAR szEditBox[500] = {0};
                CONTROL ct;
				// Look for event text in the control list
                SPLISTPOS ListPos =  m_ControlList.GetHeadPosition();
                while (ListPos) {
                   ct = m_ControlList.GetNext( ListPos );
                    if(lParam == (LPARAM)ct.hWnd) {
                        break;
                    }
                }

				// Check if there exist any submit text in the control structure. If
				// so check the control list for edit boxes that have the same
				// event text as this submit text. Because the length of the submit
				// text is used when comparing there can be more than one edit box 
				// that match the submit text.

				// Get the event text
				wcscpy(szTemp,ct.szEventText);
				// Get the submit text
				if(wcslen(ct.szSubmitText)) {
					wcscpy(szSubmit,ct.szSubmitText);
					while(ListPos) {
						ct = m_ControlList.GetNext( ListPos );
						if(!wcsnicmp(szSubmit,ct.szEventText,wcslen(szSubmit))) {
                            ::GetWindowText(ct.hWnd,szEditBox,sizeof(szEditBox)/sizeof(WCHAR));
							wcscat(szTemp,ct.szEventText);
							wcscat(szTemp,szEditBox);
							// Clear the text from the edit box
							::SetWindowText(ct.hWnd,(LPCTSTR)L"");
						}
					}
				}
				
                // Send button event string to the main thread's message loop
                ::PostThreadMessage(dwID,WM_COMMAND,(WPARAM)0,(LPARAM)szTemp);
                OUTPUT_TEXT(ct.szEventText);
				
			}
			break;
		
			
			
		//  Edit box message
		case IDC_EDIT:
			{ 
                CONTROL ct;
                SPLISTPOS ListPos =  m_ControlList.GetHeadPosition();
				// Look for event text in the control list
                while (ListPos) {
                     ct = m_ControlList.GetNext( ListPos );
                    if(lParam == (LPARAM)ct.hWnd) {
                        break;
                    }
                }
                // On set focus message a "raise keyboard" message is sent
                // to the main thread's message loop
				if (nID_N == EN_SETFOCUS) {
					//wcscpy(m_szBuf,L"TextField SetFocus{");
					wcscpy(m_szBuf,ct.szEventText);
					//wcscat(m_szBuf,L"}");
                    
					
					// Raise the keyboard
                    if (nRaiseKeyboardOnFocusGlobal) {
					::PostThreadMessage(dwID,WM_COMMAND,(WPARAM)0,(LPARAM)L"RAISEKEYBOARD");
					::PostThreadMessage(dwID,WM_COMMAND,(WPARAM)0,(LPARAM)m_szBuf);
					}
				
				
				
				// On kill focus message a "lower keyboard" message is sent
                // to the main thread's message loop.
				} else if(nID_N == EN_KILLFOCUS) {
					//::GetWindowText(ct.hWnd,szItem,MAX_TEXT_SIZE);
					//wcscpy(m_szBuf,L"TextField KillFocus {");
					//wcscpy(m_szBuf,ct.szEventText);
					//wcscat(m_szBuf,L":");
					//wcscat(m_szBuf, szItem);
					//wcscat(m_szBuf,L"}");
					// Lower the keyboard
                    ::PostThreadMessage(dwID,WM_COMMAND,(WPARAM)0,(LPARAM)L"LOWERKEYBOARD");
					// Send edit box event text to the main thread's message loop
                    //::PostThreadMessage(dwID,WM_COMMAND,(WPARAM)0,(LPARAM)m_szBuf);
				}
			
			}
			break;
		
			
		// Message from a Combo box
		// ------------------------
		case IDC_COMBO:
			{
		
				// 1 Handle the drag - down list (jek)
				// -----------------------------

				DWORD dwSel;
                CONTROL ct;
				wchar_t wcError[256];
				if(nID_N == CBN_SELENDOK) {
                     SPLISTPOS ListPos =  m_ControlList.GetHeadPosition();
					 // Look for event text in the control list
                     while (ListPos) {
                         ct = m_ControlList.GetNext( ListPos );
                        if(lParam == (LPARAM)ct.hWnd) {
                            break;
                        }
					 }  
					
					dwSel= ::SendMessage(ct.hWnd,CB_GETCURSEL,(WPARAM)0,(LPARAM)0);
					////::SendMessage(ct.hWnd,CB_GETLBTEXT,(WPARAM)dwSel,(LPARAM)szItem);

 					// swprintf(wcError,L"Index = %d, dwSel = %d\r\n",szIndex, (int)dwSel);					
					// MessageBox(wcError,NULL,MB_OK);
					
					wcscpy(m_szBuf,ct.szEventText);
					// wcscat(m_szBuf,L":");
					////wcscat(m_szBuf,szItem);
					wcscat(m_szBuf,szValues[dwSel]);
					

					// Send the combo box event text to the main thread's message loop
					::PostThreadMessage(dwID,WM_COMMAND,(WPARAM)0,(LPARAM)m_szBuf);
				} else if(nID_N == CBN_SETFOCUS) {} 
				else if(nID_N == CBN_KILLFOCUS) {}
			







				// 2 Handle the select list  (jek)
				// ------------------------
				if(nID_N == LBN_SELCHANGE ) {
                     SPLISTPOS ListPos =  m_ControlList.GetHeadPosition();
					 // Look for event text in the control list
                     while (ListPos) {
                         ct = m_ControlList.GetNext( ListPos );
                        if(lParam == (LPARAM)ct.hWnd) {
                            break;
                        }
                    }
					
					dwSel= ::SendMessage(ct.hWnd,LB_GETCURSEL,(WPARAM)0,(LPARAM)0);
					//// ::SendMessage(ct.hWnd,CB_GETLBTEXT,(WPARAM)dwSel,(LPARAM)szItem);
 					
					// swprintf(wcError,L"Index = %d, dwSel = %d\r\n",szIndex, (int)dwSel);					
					// MessageBox(wcError,NULL,MB_OK);
					wcscpy(m_szBuf,ct.szEventText);
					// wcscat(m_szBuf,L":");
					//// wcscat(m_szBuf,szItem);
					wcscat(m_szBuf,szValues[dwSel]);


					// Send the combo box event text to the main thread's message loop
					::PostThreadMessage(dwID,WM_COMMAND,(WPARAM)0,(LPARAM)m_szBuf);					
					
					
					
					/* ////
					 dwSel= ::SendMessage(ct.hWnd,LB_GETCURSEL,(WPARAM)0,(LPARAM)0);
					::SendMessage(ct.hWnd,LB_GETTEXT,(WPARAM)dwSel,(LPARAM)szItem);
					wcscpy(m_szBuf,ct.szEventText);
					wcscat(m_szBuf,L":");
					wcscat(m_szBuf,szItem);
					::PostThreadMessage(dwID,WM_COMMAND,(WPARAM)0,(LPARAM)m_szBuf);
					*/
				







				} else if(nID_N == LBN_SETFOCUS) {} 
				else if(nID_N == LBN_KILLFOCUS) {}
	
			
			}
			break;
	



	} /* end switch*/

	bHandled = TRUE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// METHOD: IEditCtrl::OnTimer
//
// COMMENT: Use a timer to synchronize the painting of an information
// text below the cursor when moving a pen/mouse over a hotspot. Use
// also a timer to synchronize the removing of the same text.
//
/////////////////////////////////////////////////////////////////////////////
LRESULT Cmapview ::OnTimer
(
    UINT    uMsg,
    WPARAM  wParam,
    LPARAM  lParam,
    BOOL &  bHandled
)
{

    int nTimerId = (int)wParam;
	RECT rectMain;
	HDC hdc = GetDC(); 
	GetRgnBox(m_pImage->m_hRgn,&rectMain); 
	// Paint the information text if a pen/mouse
	// is inside a hotspot region
	if(nTimerId == PAINT_TIMER_ID) {
		::KillTimer(m_hWnd,PAINT_TIMER_ID); 
	    SPLISTPOS ListPos =  m_HotSpotList.GetHeadPosition();
        while (ListPos) {
            HOTSPOT& hs = m_HotSpotList.GetNext( ListPos );
		    if (PtInRegion(hs.hRgn,m_dwMouseXPos,m_dwMouseYPos)) {
			    m_rectMouseText.left= m_dwMouseXPos + m_dwCursorOffsetX;
			    m_rectMouseText.top = m_dwMouseYPos + m_dwCursorOffsetY;
			    DrawText(hdc, hs.szMouseText, _tcslen(hs.szMouseText), &m_rectMouseText,DT_CALCRECT);
			    if(!PtInRegion(m_pImage->m_hRgn,m_rectMouseText.right,m_rectMouseText.bottom)) {
				    int dx = 0,dy = 0;
				    if(rectMain.right < m_rectMouseText.right) 
					    dx = m_rectMouseText.right - rectMain.right;
				    if(rectMain.bottom < m_rectMouseText.bottom)
					    dy = m_rectMouseText.bottom - rectMain.bottom;
				    m_rectMouseText.left -= dx;
				    m_rectMouseText.right -= dx;
				    m_rectMouseText.top -= dy;
				    m_rectMouseText.bottom -= dy;
			    }
				// Paint information text
			    DrawText(hdc, hs.szMouseText, _tcslen(hs.szMouseText), &m_rectMouseText,DT_WORDBREAK);
			    m_bInfoIsPainted = true;
                // Revmove the text in <n> seconds 
			    int nSecond = 2;
			    SetTimer(UPDATE_SCREEN_TIMER_ID,nSecond * 1000); 
			    break;
		    }
		}
	// Revmove the information text
	} else if (nTimerId == UPDATE_SCREEN_TIMER_ID) {
		// Repaint screen
		KillTimer(UPDATE_SCREEN_TIMER_ID);
        if(m_bInfoIsPainted)  {
            m_pImage->DrawPartOfImage(hdc,m_rectMouseText);
            RemoveDisplay(hdc,m_rectMouseText);
        }
		m_bInfoIsPainted = false;
	}

	ReleaseDC(hdc);
	
    
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// METHOD: IEditCtrl::AddToCtrl
//
// COMMENT: Put a list of text items into a combo box control
/////////////////////////////////////////////////////////////////////////////
void Cmapview ::AddToCtrl(HWND hWnd)
{
	/*PWCHAR pszSep;
	WCHAR szTemp[256];
	DWORD dwItemLength, dwIndex = 0;
	if(m_pszItems) {
		do {
			if(pszSep = wcschr((const wchar_t *)&m_pszItems[dwIndex],';')) {
				dwItemLength = pszSep - &m_pszItems[dwIndex];
				wcsncpy(szTemp,&m_pszItems[dwIndex],dwItemLength);
				wcscpy(&szTemp[dwItemLength],L"");
				AddToComboBox(hWnd,szTemp);
				dwIndex += dwItemLength + 1;
			} 
		} while(pszSep); 
	}*/
	return;
}


/////////////////////////////////////////////////////////////////////////////
// METHOD: Cmapview::ParseInputText
//
// COMMENT: Parse an input text based on a start tag (string) and a end 
// tag (string)
//
/////////////////////////////////////////////////////////////////////////////
PWCHAR Cmapview ::ParseInputText
(
 wchar_t * pszInText,  
 wchar_t * pszOutText,
 wchar_t   wcStart,
 wchar_t   wcEnd,
 PDWORD    pdwSize 
 )
{	
	wchar_t * pszStart = NULL, * pszEnd = NULL;
	memset(pszOutText,0,sizeof(wchar_t) * MAX_TEXT_SIZE);
	if(wcStart == 0) {
		pszStart = pszInText;
	} else {
		pszStart = wcschr(pszInText,(const wchar_t)wcStart);
	}
	if(pszStart &&  (pszEnd = wcschr(++pszStart,(const wchar_t)wcEnd))) {
		*pdwSize = pszEnd - pszStart;
		wcsncpy(pszOutText,pszStart,*pdwSize);
		return pszEnd;
	}			
	return NULL;
}


/////////////////////////////////////////////////////////////////////////////
// METHOD: Cmapview::put_AddToComboBox
//
// COMMENT: Put a text into the combo box control
//
/////////////////////////////////////////////////////////////////////////////
void Cmapview ::AddToComboBox(HWND hWnd, PWCHAR szBuf)
{
	ComboBox_AddString(hWnd, szBuf);
	::SetWindowText(hWnd,szBuf);
	ComboBox_SetCurSel(hWnd,/*nCnt - 1*/0);	  
  return;
}





/////////////////////////////////////////////////////////////////////////////
// METHOD: Cmapview::put_AddToListBox
//
// COMMENT: Put a text into the list box control
//
/////////////////////////////////////////////////////////////////////////////
void Cmapview ::AddToListBox(HWND hWnd, PWCHAR szBuf)
{
	ListBox_AddString(hWnd, szBuf);
	::SetWindowText(hWnd,szBuf);
	ListBox_SetCurSel(hWnd,/*nCnt - 1*/0);	  
  return;
}










/////////////////////////////////////////////////////////////////////////////
//                             Interfaces								   //
/////////////////////////////////////////////////////////////////////////////

STDMETHODIMP Cmapview::get_ControlFontSize(int * nFontSize)
{
	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////
// METHOD (PROPERTY): Cmapview ::put_ControlFontSize
//
// COMMENT: Create font size for the text on/inside the controls (button, 
//          edit box and combo box).
//
// PARAM:   nFontSize - Font size of the text.
//
/////////////////////////////////////////////////////////////////////////////


STDMETHODIMP Cmapview::put_ControlFontSize(int  nFontSize)
{	
        // Create font
    LOGFONT lf = CreateLogFont(nFontSize, 0, 0, 0, 400, false, false,      
        0, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
        DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, L"Arial");

    m_hf = (HFONT) CreateFontIndirect(&lf);
    
	return S_OK;
}


/////////////////////////////////////////////////////////////////////////////
// METHOD (PROPERTY): Cmapview ::put_SetControl
//
// COMMENT: Create a control that can be an edit box, combo box, static
//			text, button or an image. If we create an image it can be used as
//			a background image for the map application. If an image is created
//			from this method all controls on this image must be created
//			from one of the functions Cmapview::CreateButton (button), 
//			Cmapview::CreateEditBox (edit box), Cmapview::CreateComboBox
//		   (combo box) and Cmapview::CreateTextHotSpot (text) (this methods 
//          are called from a JSCRIPT). 
//
// PARAM:   bsName - Name of the control/text/image
//
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::put_Control(BSTR szName)
{

	wchar_t * pszSearch = NULL, szText[MAX_TEXT_SIZE];
	wchar_t wcStart = L':', wcSep = L',', wcEnd = L';';
	DWORD dwSize;

#ifndef UNDER_CE
	RECT rc;
	if(m_hWnd == NULL) { // This is only needed for win32
		m_bWndLess = FALSE;
		m_bWindowOnly = TRUE;
		// Create main window
		InPlaceActivate(OLEIVERB_UIACTIVATE,&rc);
		//m_bUIActive=FALSE;
		m_bInPlaceActive = FALSE;
	}
#endif

	wcscpy(m_szInputText,szName);

	// Parse input text

	if(!_wcsnicmp(m_szInputText,L"Button",wcslen(L"Button"))) {
		// Parse button text
		wcscpy(m_szCtrlName,L"BUTTON");
		m_dwStyle = WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON;
	    m_dwMenu = IDC_BUTTON;
		m_dwParamCnt++;

		if(pszSearch = wcsstr(m_szInputText,L"NAME")) {
			if(pszSearch = ParseInputText(pszSearch,&szText[0],wcStart,wcEnd,&dwSize)) {
				if (dwSize > 0) {
					wcscpy(m_szButtonName,szText);
					wcscpy(m_szCtrlText,szText);
				}	
			}
		}
	} else if(!_wcsnicmp(m_szInputText,L"Edit",wcslen(L"Edit"))) {
		// Parse edit box text
		m_dwStyle = WS_VISIBLE | WS_CHILD | WS_BORDER;
		wcscpy(m_szCtrlName,L"EDIT");
		m_dwMenu = IDC_EDIT;
		m_dwParamCnt++;

		if(pszSearch = wcsstr(m_szInputText,L"SETFOCUS")) {
			m_bSetFocus = TRUE;
		}
		if(pszSearch = wcsstr(m_szInputText,L"NAME")) {
			if(pszSearch = ParseInputText(pszSearch,&szText[0],wcStart,wcEnd,&dwSize)) {
				if (dwSize > 0) 
					wcscpy(m_szEditBoxName,szText);	
			}
		}
		if(pszSearch = wcsstr(m_szInputText,L"TEXT")) {
			if(pszSearch = ParseInputText(pszSearch,&szText[0],wcStart,wcEnd,&dwSize)) {
				if (dwSize > 0) {
					wcscpy(m_szEditBoxText,szText);
					wcscpy(m_szCtrlText,szText);
				} else {
					wcscpy(m_szCtrlText,L"");
				}
			}
		}
	} else if(!_wcsnicmp(m_szInputText,L"COMBOBOX",wcslen(L"COMBOBOX"))) {
		// Parse combo box text
		m_dwStyle = CBS_DROPDOWN | CBS_NOINTEGRALHEIGHT | 
			WS_VSCROLL | WS_TABSTOP | WS_VISIBLE | WS_CHILD;
		wcscpy(m_szCtrlName,L"COMBOBOX");
		m_dwMenu = IDC_COMBO;
		m_dwParamCnt++;

		if(pszSearch = wcsstr(m_szInputText,L"NAME")) {
			if(pszSearch = ParseInputText(pszSearch,&szText[0],wcStart,wcEnd,&dwSize)) {
				if (dwSize > 0) {
					wcscpy(m_szComboBoxName,szText);
					wcscpy(m_szCtrlText,szText);
				}	
			}
		}
		
	}  else if(!_wcsnicmp(m_szInputText,L"STATIC",wcslen(L"STATIC"))) {
		// Parse static text

		// Get the text
		if(pszSearch = wcsstr(m_szInputText,L"TEXT")) {
			if(pszSearch = ParseInputText(pszSearch,&szText[0],wcStart,wcEnd,&dwSize)) {
				if (dwSize > 0)
					wcscpy(m_szStaticText,szText);
			} 
		}
		// Get the text ID
		if(pszSearch = wcsstr(m_szInputText,L"TEXTID")) {
			if(pszSearch = ParseInputText(pszSearch,&szText[0],wcStart,wcEnd,&dwSize)) {
				if (dwSize > 0)
					wcscpy(m_szStaticTextID,szText);
			}
		}
		// Check if the text is underline
		if(pszSearch = wcsstr(m_szInputText,L"UNDERLINE")) {
			m_bUnderline = TRUE;
		}
		DWORD dwRed = 0, dwGreen = 0, dwBlue = 0;
		wcStart = L':';
		// Get the background color
		if(pszSearch = wcsstr(m_szInputText,L"RGBBACK")) {
			for (int i = 0; i < 3 ; i++) {
				if(pszSearch = ParseInputText(pszSearch,&szText[0],wcStart,wcSep,&dwSize)) {
					if (dwSize > 0) {
						if(i==0) {
							dwRed = _wtoi(szText);
							wcStart = wcSep;
						}
						else if (i==1) {
							dwGreen = _wtoi(szText);
							wcSep = wcEnd;
						}
						else if (i==2) 
							dwBlue = _wtoi(szText);
					}
				}
			}
		}
		// Set the background color
		m_crTextBkColor = RGB(dwRed,dwGreen,dwBlue);
		dwRed = 255; dwGreen = 255; dwBlue = 255;
		wcStart = L':', wcSep = L',';
		// Get the font color
		if(pszSearch = wcsstr(m_szInputText,L"RGBFONT")) {
			for (int i = 0; i < 3 ; i++) {
				if(pszSearch = ParseInputText(pszSearch,&szText[0],wcStart,wcSep,&dwSize))  {
					if (dwSize > 0) {
						if(i==0) {
							dwRed = _wtoi(szText);
							wcStart = wcSep;
						}
						else if (i==1) {
							dwGreen = _wtoi(szText);
							wcSep = wcEnd;
						}
						else if (i==2) 
							dwBlue = _wtoi(szText);
					}
				}
			}
		}
		// Set the font color
		m_crTextColor = RGB(dwRed,dwGreen,dwBlue);

	} else  if(!_wcsnicmp(m_szInputText,L"IMAGE",wcslen(L"IMAGE"))) {
		// Create image
		HDC hdc = GetDC();
		m_pImage = new CVOImage();
		if(pszSearch = wcsstr(m_szInputText,L"FILENAME")) {
			wcStart = L':',wcEnd = L';';
			if(pszSearch = ParseInputText(pszSearch,&szText[0],wcStart,wcEnd,&dwSize)) {
				if (dwSize > 0) {
					wcscpy(m_szImageName,szText);
					// Load Image
					if(!m_pImage->LoadBkImage((HINSTANCE)ghInstance,hdc,m_szImageName,m_szDefaultPath)) {
					    // Error check in the sub functions
						::MessageBox(NULL, L"Failed loading background image", L"Error", MB_OK);
						}
					//::MessageBox(NULL, L"Failed loading background image", L"Error", MB_OK);
					// Make a rectangular region, so we can get mouse events from the image.
					m_pImage->m_hRgn = CreateRectRgn(0,0,m_pImage->m_dwWidth,m_pImage->m_dwHeight);
				}
			}
		}
		ReleaseDC(hdc);
	}
	// Send information to the container
	FireViewChange();
    SendOnDataChange(NULL);

	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::CreateTransparentHotspot
//
// COMMENT: Create a transparent hotspot.  The point of using this type of 
//          hotspot is that the user can make an aerea mouse censetive
//          without painting enything on the background image. 
//          The shape of the censitive aera is a rectangle.  
//
// PARAMS:  bsEventText - Text that will be sent back to the server when a
//          pen pushed on the screen generate an event.
//          bsMouseText - Text that pops up when a pen move over a hotspot.
//          nLeft - The x-coordinate of the upper-left corner of a rectangle. 
//          nTop - The y-coordinate of the upper-left corner of a rectangle. 
//          nRight   - The width of the rectangle.
//		    nBottom  - The hight of the rectangle.
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::CreateTransparentHotspot(BSTR bsEventText, 
												BSTR bsMouseText, 
												int  nLeft, 
												int  nTop, 
												int  nRight, 
												int  nBottom)
{

    RECT rc;

    rc.left   = nLeft;
	rc.top    = nTop;
	rc.right  = nLeft + nRight;
	rc.bottom = nTop  + nBottom;
	
    HOTSPOT hs;

    hs.hRgn = 0;
	wcscpy(hs.szMouseText,L"");
    wcscpy(hs.szEventText,L"");
    wcscpy(hs.szShapeType,L"");

    hs.bFiller = FALSE;
    hs.hBitmap = NULL;
	hs.bTransparentHotspotEvent = m_bTransparentHotspotEvent;
	
	// Mouse text
	wcscpy(hs.szMouseText,bsMouseText);
	// Event text
    wcscpy(hs.szEventText,bsEventText);
	
	// Create a pen censetive region
    hs.hRgn = CreateRectRgnIndirect(&rc);
	// Add the hotspot to a list of hotspots
    m_HotSpotList.AddTail(hs);
	
    return S_OK;
}



/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::CreatePaintedHotspot
//
// COMMENT: Create a painted hotspot. The hotspot can be a rectangle or 
//          an ellipse with border, filler or it can be transparent.   
//
// PARAMS:  bsEventText - Text that will be sent back to the server when a
//          pen pushed on the screen generate an event.
//          bsMouseText - Text that pops up when a pen move over a hotspot.
//          bsShapeType - Shape that is a rectangle or an ellipse.
//          nFiller - Fill the rectangle/ellipse with a colour if the input
//          value is TRUE else there is no filler.
//          nLeft    - The x-coordinate of the upper-left corner of a rectangle.
//          nTop     - The y-coordinate of the upper-left corner of a rectangle.
//          nRight   - The width of the rectangle.
//		    nBottom  - The hight of the rectangle.
//
/////////////////////////////////////////////////////////////////////////////

STDMETHODIMP Cmapview::CreatePaintedHotspot(BSTR bsEventText, 
											BSTR bsMouseText, 
											BSTR bsShapeType, 
											int  nFiller, 
											int  nLeft, 
											int  nTop, 
											int  nRight, 
											int  nBottom)
{

	HDC hDC = GetDC();
    RECT rc;

    rc.left   = nLeft;
	rc.top    = nTop;;
	rc.right  = nLeft + nRight;
	rc.bottom = nTop + nBottom;
	
    HOTSPOT hs;

    hs.hRgn = 0;
	wcscpy(hs.szMouseText,L"");
    wcscpy(hs.szEventText,L"");
    wcscpy(hs.szShapeType,L"");
 
    hs.bFiller = FALSE;
    hs.hBitmap = NULL;
    hs.dwPenWidth = m_dwPenWidth;
	hs.bTransparentHotspotEvent = m_bTransparentHotspotEvent;
	// Fill in the border/filler colors
    if(nFiller) {
        hs.bFiller = TRUE;
        hs.crFillerColor = m_crFillerColor;
    } else {
        hs.bFiller = FALSE;
        hs.crBorderColor = m_crBorderColor;
    }
	// Mouse text
	wcscpy(hs.szMouseText,bsMouseText);
	// Event text
    wcscpy(hs.szEventText,bsEventText);
	// Shape type
    wcscpy(hs.szShapeType,bsShapeType);
	// Create a pen censetive region
    hs.hRgn = CreateRectRgnIndirect(&rc);
	// Add the hotspot to a list of hotspots
    m_HotSpotList.AddTail(hs);
#ifdef PPC2002
	// Paint hotspot
	if(m_pImage) 
		m_pImage->PaintHotSpot(hDC,hs);
#endif

	ReleaseDC(hDC);

    return S_OK;
} 

/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::CreatePaintedEvent
//
// COMMENT: Create a painted event. The event can be a rectangle or 
//          an ellipse with border or filler. The event is painted
//          when a pen is pushed on a hotspot. The event is connected
//          to the hotspot through the event text (the text is the same).
//          Example: The event can be used to change boder color to a 
//          rectangle or an ellipse when a pen is pushed on a hotspot.  
//
// PARAMS:  bsEventText - Text that connect the event to a hotspot (need
//          to be the same as the hotspot).
//          bsShapeType - Shape that is a rectangle or an ellipse.
//          nFiller - Fill the rectangle/ellipse with a colour if the input
//          value is TRUE else there is no filler.
//          nLeft - The x-coordinate of the upper-left corner of a rectangle. 
//          nTop - The y-coordinate of the upper-left corner of a rectangle. 
//          nRight   - The width of the rectangle.
//		    nBottom  - The hight of the rectangle.
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::CreatePaintedEvent(BSTR bsEventText, 
										  BSTR bsShapeType, 
										  int  nFiller, 
										  int  nLeft, 
										  int  nTop, 
										  int  nRight, 
										  int  nBottom)
{

    RECT rc;
    rc.left = nLeft;
	rc.top = nTop;
	rc.right = nLeft + nRight;
	rc.bottom = nTop + nBottom;

    EVENT ie;
    ie.hRgn = 0;
    wcscpy(ie.szEventText,L"");
	wcscpy(ie.szShapeType,L"");
    ie.hBitmap = NULL;
    ie.bFiller = FALSE;
	ie.dwPenWidth = m_dwPenWidth;
	// Fill inn information about the border/filler colors
    if(nFiller) {
        ie.bFiller = TRUE;
        ie.crEventFillerColor = m_crEventFillerColor;
    } else {
        ie.bFiller = FALSE;
        ie.crEventBorderColor = m_crEventBorderColor;
    }
	// Shape type
    wcscpy(ie.szShapeType,bsShapeType);
	// Event text that connect the event to a hotspot
	wcscpy(ie.szEventText,bsEventText);
	
    ie.hRgn = CreateRectRgnIndirect(&rc);
	// Add the event structure to a list of events
    m_EventList.AddTail(ie);


    return S_OK;
}
/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::CreateTextEvent
//
// COMMENT: Paint a text when a pen is pushed on a hotspot. The event is 
//          connected to the hotspot through an event text. 
//
// PARAMS:  bsText - Text that pops up when a pen is pushed on a hotspot.
//          bsEventText - Text that connect this event to a hotspot.
//          nLeft - The x-coordinate for the text's starting point.
//          nTop - The y-coordinate for the text's starting point.
//          nRight   - The width of the rectangle.
//		    nBottom  - The hight of the rectangle.
//
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::CreateTextEvent(BSTR sbText, 
									   BSTR sbEventText, 
									   int  nBorder, 
									   int  nBorderWidth, 
									   int  nLeft, 
									   int  nTop, 
									   int  nRight, 
									   int  nBottom) {



	HDC hDC = GetDC();
    EVENT ev;

	if(nBorder) ev.bBorder = true;
	else ev.bBorder = false;

	if(nBorderWidth > 0) 
		ev.dwBorderWidth = (DWORD) nBorderWidth;
	else
		ev.dwBorderWidth = 0;

	ev.dwPenWidth = m_dwPenWidth;
	ev.hRgn = 0;
    wcscpy(ev.szEventText,L"");
    wcscpy(ev.szShapeType,L"");
    wcscpy(ev.szText,L"");
    ev.bFiller = FALSE;
    ev.hBitmap = NULL;
	ev.crEventBorderColor = m_crEventBorderColor;
	
   	  
    // Add font information
    wcscpy(ev.font.szFontType,m_szFontType);
    ev.font.crTextBkColor = m_crTextBkColor;
    ev.font.crTextColor = m_crTextColor;
    ev.font.bUnderLine = m_bUnderline;
    ev.font.bTransparent = m_bTransparent;
    ev.font.bItalic = m_bItalic;  
    ev.font.dwFontSize = m_dwFontSize;  
    
    // Add text and event text (text that is sent to server with mouse notifications)
    wcscpy(ev.szText,sbText);
    wcscpy(ev.szShapeType,L"Text");
	wcscpy(ev.szEventText,sbEventText);

    RECT rc;
    rc.top = nTop;
    rc.left = nLeft;
    rc.right = nLeft + nRight;
    rc.bottom = nTop + nBottom;

    HFONT hf;
    
    LOGFONT lf = CreateLogFont(m_dwFontSize, 0, 0, 0, 400, m_bItalic, m_bUnderline,      
        0, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
        DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, m_szFontType);

  
    hf = (HFONT) SelectObject(hDC,CreateFontIndirect(&lf));

    
    // Paint the background color and the font color
	SetBkColor(hDC,m_crTextBkColor);
	SetTextColor(hDC,m_crTextColor);

	// Use the DrawText function to get the actual size of the hotspot rectangle (text):
    DrawText(hDC, ev.szText, _tcslen(ev.szText), &rc,DT_CALCRECT | DT_WORDBREAK);

    rc.left -= ev.dwBorderWidth;
	rc.top -= ev.dwBorderWidth;
	rc.bottom += ev.dwBorderWidth;
	rc.right += ev.dwBorderWidth;
	
	// Create a rectangular region
    ev.hRgn = CreateRectRgnIndirect(&rc);

	// Add text event to a list of events
    m_EventList.AddTail(ev);
  
    DeleteObject(SelectObject(hDC,hf));

    ReleaseDC(hDC);

    return S_OK;
}

/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::CreateImageEvent
//
// COMMENT: Paint an image when a pen is pushed on a hotspot. The event is 
//          connected to the hotspot through an event text. 
//
// PARAMS:  bsEventText - Text that connect this event to a hotspot.
//          bsImageEventName - Name, include path, for the image.
//          nLeft - The x-coordinate for the image's starting point.
//          nTop - The y-coordinate for the image's starting point.
//
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::CreateImageEvent(BSTR bsEventText, 
										BSTR bsImageEventName, 
										int  nLeft, 
										int  nTop)
{

    HDC hDC;
    if (m_pImage) {   
        EVENT ie;
        ie.hRgn = 0;
        wcscpy(ie.szEventText,L"");
        ie.hBitmap = NULL;
	    ie.dwRemoveImageColor = m_dwRemoveImageColor;

        hDC = GetDC();
        HBITMAP hBm;

		OUTPUT_TEXT(bsImageEventName);
        
        // Load hotspot image
		if((hBm = m_pImage->LoadHotSpotImageFile((HINSTANCE)ghInstance,hDC,bsImageEventName,m_szDefaultPath)) == NULL) {
		    // There is error handling in the method  CVOImage::LoadHotSpotImageFile 
            return E_FAIL;
		}

        ie.hBitmap = hBm;

        BITMAP	bmp;
	    GetObject(hBm, sizeof(BITMAP), &bmp);

        ie.hRgn = CreateRectRgn(nLeft,nTop,(nLeft + bmp.bmWidth),(nTop + bmp.bmHeight));
        
        wcscpy(ie.szEventText,bsEventText);
		// Set the threshold value for the image. This value
        ie.crImageThresholdColor = m_crImageThresholdColor;

        // Add the EVENT structure to the tail of a linked list
        m_EventList.AddTail(ie);

        ReleaseDC(hDC);

    }


    return S_OK;
}
/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::CreateImageHotspot
//
// COMMENT: Paint an image hotspot.  
//
// PARAMS:  bsEventText - Text that connect this event to a hotspot.
//          bsImageName - Name, include path, for the image.
//          nLeft - The x-coordinate for the image's starting point.
//          nTop - The y-coordinate for the image's starting point.
//
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::CreateImageHotspot(BSTR bsEventText, 
										  BSTR bsMouseText, 
										  BSTR bsImageName, 
										  int  nLeft, 
										  int  nTop) {

    HDC hDC;
   
    if (m_pImage) {    
        hDC = GetDC();
        HBITMAP hBm;

        HOTSPOT hs;
		
		hs.hRgn = 0;
		wcscpy(hs.szMouseText,L"");
        wcscpy(hs.szEventText,L"");
        wcscpy(hs.szShapeType,L"");
        wcscpy(hs.szText,L"");
        hs.bFiller = FALSE;
        hs.hBitmap = NULL;
		hs.dwRemoveImageColor = m_dwRemoveImageColor;
		hs.bTransparentHotspotEvent = m_bTransparentHotspotEvent;

		OUTPUT_TEXT(bsImageName);
        
        // Load hotspot image
		if((hBm = m_pImage->LoadHotSpotImageFile((HINSTANCE)ghInstance,hDC,bsImageName,m_szDefaultPath)) == NULL) {
			// There is error handling in the method  CVOImage::LoadImageFile 
            return E_FAIL;
		}

        hs.hBitmap = hBm;
        BITMAP	bmp;
	    GetObject(hBm, sizeof(BITMAP), &bmp);
        hs.hRgn = CreateRectRgn(nLeft,nTop,(nLeft + bmp.bmWidth),(nTop + bmp.bmHeight));
        wcscpy(hs.szMouseText,bsMouseText);
        wcscpy(hs.szEventText,bsEventText);        
        hs.crImageThresholdColor = m_crImageThresholdColor;


#ifdef PPC2002
        m_pImage->DrawHotSpotIcon(hDC,hs);
#endif

		// Add the HOTSPOT structure to the tail of a linked list
        m_HotSpotList.AddTail(hs);

        ReleaseDC(hDC);

    }


    return S_OK;
}
/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::CreateTextHotspot
//
// COMMENT: Paint a text hotspot.  
//
// PARAMS:  sbText       - Text inside the hotspot
//          sbEventText  - Text that is sent to the server if hotspot is tapped on. 
//          nDynamicSize - If TRUE (1), the size of the object is adapted to 
//                         the text.
//          nBorder      - If TRUE, a border will bw applyed.
//          nBorderWidth - Actually the distance between the text and the border
//          nLeft        - The x-coordinate for the text's starting point.
//          nTop         - The y-coordinate for the text's starting point.
//          nRight       - The width of the rectangle.
//		    nBottom      - The hight of the rectangle.
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::CreateTextHotSpot(BSTR sbText, 
										 BSTR sbEventText,
										 int  nDynamicSize,
										 int  nBorder,
										 int  nBorderWidth, 
										 int  nLeft,  
										 int  nTop, 
										 int  nRight, 
										 int  nBottom)
{
 
    HDC hDC = GetDC();
    HOTSPOT hs;
   
	if(nBorder) hs.bBorder = true;
	else hs.bBorder = false;

	if(nBorderWidth > 0)
		hs.dwBorderWidth = (DWORD) nBorderWidth;
	else
		hs.dwBorderWidth = 0; 

	hs.dwPenWidth = m_dwPenWidth;
	hs.bTransparentHotspotEvent = m_bTransparentHotspotEvent;
  
	hs.hRgn = 0;
	wcscpy(hs.szMouseText,L"");
    wcscpy(hs.szEventText,L"");
    wcscpy(hs.szShapeType,L"");
    wcscpy(hs.szText,L"");
    hs.bFiller = FALSE;
    hs.hBitmap = NULL;
	hs.crBorderColor = m_crBorderColor;
   
   
		  
    // Add font information
    wcscpy(hs.font.szFontType,m_szFontType);
    hs.font.crTextBkColor   = m_crTextBkColor;
    hs.font.crTextColor     = m_crTextColor;
    hs.font.bUnderLine      = m_bUnderline;
    hs.font.bTransparent    = m_bTransparent;
    hs.font.bItalic         = m_bItalic;  
    hs.font.dwFontSize      = m_dwFontSize;  
    
    // Add text and event text (text that is sent to server with mouse notifications)
    wcscpy(hs.szText,      sbText);
    wcscpy(hs.szEventText, sbEventText);
    wcscpy(hs.szShapeType, L"Text");

    RECT rc;
    rc.top    = nTop;
    rc.left   = nLeft;
    rc.right  = nLeft + nRight;
    rc.bottom = nTop  + nBottom;

    HFONT hf;
    
    LOGFONT lf = CreateLogFont(m_dwFontSize, 0, 0, 0, 400, m_bItalic, m_bUnderline,      
		0, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
        DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, m_szFontType);

  
    hf = (HFONT) SelectObject(hDC,CreateFontIndirect(&lf));

    // Paint the background color and the font color
	SetBkColor(hDC,   m_crTextBkColor);
	SetTextColor(hDC, m_crTextColor);

    // Use the DrawText function to get the actual size of the hotspot rectangle (text):
	 if (nDynamicSize) {
		DrawText(hDC, hs.szText, _tcslen(hs.szText), &rc,DT_CALCRECT | DT_WORDBREAK);
		// rc.left   -= hs.dwBorderWidth;
		// rc.top    -= hs.dwBorderWidth;
		rc.bottom += hs.dwBorderWidth*2;
		rc.right  += hs.dwBorderWidth*2;
	 }

    // Create a region that will generate events when a pen is pushed on the screen
	hs.hRgn = CreateRectRgnIndirect(&rc);

#ifdef PPC2002
	if(m_pImage)
		m_pImage->PaintHotSpot(hDC,hs);
#endif

    // Add the text hotspot to a list of hotspots
	m_HotSpotList.AddTail(hs);
  
    DeleteObject(SelectObject(hDC,hf));

    ReleaseDC(hDC);

    return S_OK;
}

/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::CreateButton
//
// COMMENT: Create a button control. When using the submit text the button
//          get the text inside the edit boxes in addition to the edit boxes
//          event text. 
//
// PARAMS:  sbButtonText - Text on the button
//          sbEventText - Text that will be sent back to the server when a
//          pen is pushed on the button.
//          sbSubmitText - Text that connect the button to one or more edit
//          boxes thrue the edit boxes event text. 
//          nLeft - The x-coordinate of the upper-left corner of a rectangle. 
//          nTop - The y-coordinate of the upper-left corner of a rectangle. 
//          nRight       - The width of the rectangle.
//		    nBottom      - The hight of the rectangle.
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::CreateButton(BSTR sbButtonText,  
									BSTR sbEventText, 
									BSTR sbSubmitText, 
									int  nLeft, 
									int  nTop, 
									int  nRight, 
									int  nBottom) {

    CONTROL ct;  
    ct.hWnd = 0;
    wcscpy(ct.szEventText,L"");
	wcscpy(ct.szSubmitText,L"");
	
    HWND hWnd = ::CreateWindow(
		    L"BUTTON",
		    sbButtonText,
		    WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
		    nLeft, nTop, nRight, nBottom, 
		    m_hWnd,
		    (HMENU)IDC_BUTTON,
		    (HINSTANCE)ghInstance,
		    NULL 
		    );
    
	if(m_hf)
		::SendMessage(hWnd,WM_SETFONT,(WPARAM) m_hf,MAKELPARAM(true,0));

	wcscpy(ct.szSubmitText,sbSubmitText);
    wcscpy(ct.szEventText,sbEventText);
    ct.hWnd = hWnd;
#ifdef PPC2002
    ::UpdateWindow(hWnd); 
    ::ShowWindow(hWnd,SW_SHOW);
#endif 

    // Add the control to a list of controls
    m_ControlList.AddTail(ct);

    return S_OK;
}



/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::CreateEditBox
//
// COMMENT: Create an edit box (control).  
//
// PARAMS:  bsEditText - Start text inside the edit box.
//          bsEventText - Text that will be sent back to a server when a
//          pen is set inside the edit box.
//          nFocus - If TRUE the focus is set on the edit box => the keyboard
//          is also raised.
//          nDisable - If TRUE the user can't type text into the edit control. 
//          nLeft - The x-coordinate of the upper-left corner of a rectangle. 
//          nTop - The y-coordinate of the upper-left corner of a rectangle. 
//          nRight       - The width of the rectangle.
//		    nBottom      - The hight of the rectangle.
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::CreateEditBox(BSTR bsEditText, 
									 BSTR bsEventText,
									 int  nCloseButton,
									 BSTR bsTitle,
									 int  nFocus,
									 int  nRaiseKeyboardOnFocus,
									 int  nDisable, 
									 int  nLeft, 
									 int  nTop, 
									 int  nRight, 
									 int  nBottom) {

    
	
	// NOTE: mbstowcs doesnt work properly with 8-bit ascii
	// char *tst = "Hei og h   slutts";
	// wchar_t wcData[512];
	// mbstowcs(wcData,tst,strlen(tst)); 
	////::MessageBox(NULL,wcData,L"Information",MB_OK);	
	// BSTR tst2 = L"Test  slutt";
	////::MessageBox(NULL,tst2,L"Information",MB_OK);




	CONTROL ct;  
    ct.hWnd = 0;
    wcscpy(ct.szEventText,L"");


	DWORD dwStyle = ES_MULTILINE | ES_AUTOVSCROLL |WS_VISIBLE | WS_CHILD | WS_BORDER ;
	

	if (nCloseButton) {
		dwStyle |= WS_SYSMENU | WS_CAPTION; 
	}



    // Disable the edit box

	if(nDisable) { // jek added | WS_SYSMENU | WS_CAPTION - dont work - you cannott click on 'x'
		// dwStyle |= ES_READONLY | WS_SYSMENU | WS_CAPTION;
		dwStyle |= WS_DISABLED;
		// dwStyle |= WS_SYSMENU;
	}


	if (nRaiseKeyboardOnFocus) {
		nRaiseKeyboardOnFocusGlobal = 1;
	}
	else {
		nRaiseKeyboardOnFocusGlobal = 0;
	}




	HWND hWnd;



	// Create edit box
	

	// Note, if WS_SYSMENU is set, the role of bsEditText and bsTitle is swapped
	if (!nCloseButton) {
		
		hWnd = ::CreateWindow(
			L"EDIT",
			bsEditText,
			dwStyle,
			nLeft, nTop, nRight, nBottom, 
			m_hWnd,
			(HMENU)IDC_EDIT,
			(HINSTANCE)ghInstance,
			NULL
			);
	}
	else {
		
		hWnd = ::CreateWindow(
			L"EDIT",
			bsTitle,
			dwStyle,
			nLeft, nTop, nRight, nBottom, 
			m_hWnd,
			(HMENU)IDC_EDIT,
			(HINSTANCE)ghInstance,
			NULL
			);
	}
	


	if(m_hf)
		::SendMessage(hWnd,WM_SETFONT,(WPARAM) m_hf,MAKELPARAM(true,0));
    

    
	
	// WARNING: THE ORDER OF THE STATEMENTS BELOW ARE CRITICAL
	wcscpy(ct.szEventText,bsEventText);

    ct.hWnd = hWnd;

#ifdef PPC2002
    ::UpdateWindow(hWnd); 
    ::ShowWindow(hWnd,SW_SHOW);
#endif

   // Add the control to a list of controls
    m_ControlList.AddTail(ct);



	// Set focus and raise the keyboard
    if(nFocus && !nDisable) { 
		::SetFocus(hWnd);

		// jek: Raise the keyboard 
		// Note: This code segment simply select the editbox -> 
		//       keyboard is raised ?? or ...
		
		BOOL fRes = FALSE;
		SIPINFO si;
		memset(&si,0,sizeof(si));
		si.cbSize = sizeof(si);
		if(SHSipInfo(SPI_GETSIPINFO,0,&si,0)) {
			si.fdwFlags |= SIPF_ON;
			fRes = SHSipInfo(SPI_SETSIPINFO,0,&si,0);
		}

	}
 

		// finally set the title if nCloseButton is TRUE
		if (nCloseButton) {
		::SendMessage(hWnd, WM_SETTEXT, 0, (LPARAM)bsEditText); 
		}



   return S_OK;

									 
	/*
	// version with first letter as capital
		SHInitExtraControls();
		HWND hWnd = ::CreateWindow(
			TEXT("CAPEDIT"),
		    TEXT(""),
		    WS_TABSTOP|WS_VISIBLE|WS_BORDER,
			nLeft, nTop, nRight, nBottom, 
			m_hWnd, 
			NULL,
			(HINSTANCE)ghInstance, 
			NULL);

*/



}






// jek: This version don't work - gives display flash, and submit
// button don't work - ie dont send the text in edit window
// The bug is here:
//	if ( !(nFocus && !nDisable) ) {
// 	    ct.hWnd = hWnd;
//#ifdef PPC2002
//	    ::UpdateWindow(hWnd); 
//	    ::ShowWindow(hWnd,SW_SHOW);
//#endif

 /*
STDMETHODIMP Cmapview::CreateEditBoxNew(BSTR bsEditText, 										
									 BSTR bsEventText,
									 int nFocus,
									 int nDisable, 
									 int nLeft, 
									 int nTop, 
									 int nRight, 
									 int nBottom) {

    
	
	
	
	
	CONTROL ct;  
    ct.hWnd = 0;
    wcscpy(ct.szEventText,L"");

	DWORD dwStyle = ES_MULTILINE | ES_AUTOVSCROLL |WS_VISIBLE | WS_CHILD | WS_BORDER;
	
    // Disable the edit box

	if(nDisable) {
		dwStyle |= WS_DISABLED;
	}


	////	
	////	LPARAM  lParam; 
	////	// CONTROL ct;
	////	SPLISTPOS ListPos =  m_ControlList.GetHeadPosition();		
	////	// Look for event text in the control list
	////	while (ListPos) {
	////		ct = m_ControlList.GetNext( ListPos );
	////		if(lParam == (LPARAM)ct.hWnd) {
	////			break;
	////		}
	////	}
	////	DWORD dwID = GetCurrentThreadId();
	////	wcscpy(m_szBuf,ct.szEventText);		
	////	::PostThreadMessage(dwID,WM_COMMAND,(WPARAM)0,(LPARAM)L"RAISEKEYBOARD");
	////	::PostThreadMessage(dwID,WM_COMMAND,(WPARAM)0,(LPARAM)m_szBuf);
	
	


	// Create edit box
    HWND hWnd = ::CreateWindow(
		    L"EDIT",
		    bsEditText,
		    dwStyle,
		    nLeft, nTop, nRight, nBottom, 
		    m_hWnd,
		    (HMENU)IDC_EDIT,
		    (HINSTANCE)ghInstance,
		    NULL
		    );




	if(m_hf) {
		::SendMessage(hWnd, WM_SETFONT, (WPARAM) m_hf, MAKELPARAM(true,0));
	}
    

    wcscpy(ct.szEventText,bsEventText);

	// Set focus on editable keyboard, and raise keyboard 
	if(nFocus && !nDisable) {
		
		::SetFocus(hWnd);

		//// jek: only works for ppc2000 ???
		////	DWORD dwID = GetCurrentThreadId();
		////	::PostMessage(hWnd, WM_COMMAND,(WPARAM)0,(LPARAM)L"RAISEKEYBOARD");
		////	// ::SendMessage(hWnd, WM_COMMAND, (WPARAM) m_hf, MAKELPARAM(true,0));
		
	
		// Raise the keyboard
		BOOL fRes = FALSE;
		SIPINFO si;
		memset(&si,0,sizeof(si));
		si.cbSize = sizeof(si);
		if(SHSipInfo(SPI_GETSIPINFO,0,&si,0)) {
			si.fdwFlags |= SIPF_ON;
			fRes = SHSipInfo(SPI_SETSIPINFO,0,&si,0);
		}
	}

	// For win2002, update screen if not RAISEKEYBOARD
	if ( !(nFocus && !nDisable) ) {
		ct.hWnd = hWnd;
#ifdef PPC2002
		::UpdateWindow(hWnd); 
		::ShowWindow(hWnd,SW_SHOW);
#endif
	}

    // Add the control to a list of controls
    m_ControlList.AddTail(ct);


    return S_OK;

}

*/



/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::CreateComboBox
//
// COMMENT: Create a combo box (control).  
//
// PARAMS:  bsBoxType - type of box : options: "ComboBox" or "ListBox"
//          bsEventText - Text that will be sent back to a server when a
//          pen is pushed on an item inside the combo box.
//          bsItems - Text items inside the combo box. The items are separated
//          with ";".
//          nLeft - The x-coordinate of the upper-left corner of a rectangle. 
//          nTop - The y-coordinate of the upper-left corner of a rectangle. 
//          nRight       - The width of the rectangle.
//		    nBottom      - The hight of the rectangle.
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::CreateComboBox(BSTR bsBoxType,
									  BSTR bsTitle,
									  BSTR bsEventText,
									  BSTR bsItems, 
									  BSTR bsValues, 
									  int  nLeft, 
									  int  nTop, 
									  int  nRight, 
									  int  nBottom
									  )
{
    
    CONTROL ct;  
    ct.hWnd = 0;
    wcscpy(ct.szEventText,L"");
	HWND hWnd;

	 
	// 1 Create a combo box
	if (wcscmp(L"ComboBox",(wchar_t *)bsBoxType) == 0 ) {
		
		hWnd = ::CreateWindow(
			L"COMBOBOX",
			// L"Select facility",
			bsTitle,
			CBS_DROPDOWNLIST | CBS_NOINTEGRALHEIGHT | WS_VSCROLL | WS_TABSTOP | WS_VISIBLE | WS_CHILD,
			nLeft, nTop, nRight, nBottom, 
			m_hWnd,
			(HMENU)IDC_COMBO,
			(HINSTANCE)ghInstance,
			NULL
			);
	}

	else if (wcscmp(L"ListBox",(wchar_t *)bsBoxType) == 0 ) { 
		
		// 2 create the list box
		hWnd =  ::CreateWindow(L"LISTBOX", 
			// L"Select facility",
			bsTitle,
			// LBS_STANDARD | WS_SYSMENU | WS_CAPTION |WS_OVERLAPPED | LBS_DISABLENOSCROLL | WS_TABSTOP | WS_VISIBLE | WS_CHILD,
			LBS_NOTIFY | WS_SYSMENU | WS_CAPTION  | LBS_DISABLENOSCROLL | WS_TABSTOP | WS_VSCROLL | WS_VISIBLE | WS_CHILD,
			nLeft, nTop, nRight, nBottom, 
			m_hWnd,
			(HMENU)IDC_COMBO,
			(HINSTANCE)ghInstance,
			NULL
			);
	}
	else {
			
		ErrorMessageBox((wchar_t *)bsBoxType);
		ErrorMessageBox(L"Fatal Error: Wrong boxtype given to CreateCombobox()\n");
		exit(0);
	}


	// jek dont work ?
	// hWnd->setTitle("hallo");


	if(m_hf)
		::SendMessage(hWnd,WM_SETFONT,(WPARAM) m_hf,MAKELPARAM(true,0));


		  
	wcscpy(ct.szEventText,bsEventText);
 
    ct.hWnd = hWnd;

 	
	
	
	
	// Fill the combo box with items
	DWORD dwTextLength      = wcslen(bsItems) + 1;
	DWORD dwEventTextLength = wcslen(bsEventText);	
	WCHAR szTextItem[256], szItem[256];
	PWCHAR pszTemp          = NULL, pszStart;
	wcscpy(szTextItem,L"");



	if(dwTextLength && dwEventTextLength) {

		if (!(pszTemp = new WCHAR[dwTextLength + 1])) {
			MessageBox(L"Can't create new memory in function CreateComboBox",NULL,MB_OK);
			return E_OUTOFMEMORY;
		}

		

		// Put the items inside the combo box. The items are separated with ";"
		pszStart = pszTemp;
		memset(pszTemp,0,dwTextLength * sizeof(WCHAR));
		wcscpy(pszTemp,L";");
		wcscat(pszTemp,bsItems);
		wchar_t wcStart = 0,wcEnd = ';'; // Start and end separator for parsing text
		DWORD dwSize = 0;
		do {
			if(pszTemp = ParseInputText(pszTemp,&szItem[0],wcStart,wcEnd,&dwSize)) {	
				if (wcscmp(L"ComboBox",(wchar_t *)bsBoxType) == 0 ) {
					if(dwSize > 1) AddToComboBox(hWnd,szItem);
				}
				else if (wcscmp(L"ListBox",(wchar_t *)bsBoxType) == 0 ) {
					if(dwSize > 1) AddToListBox(hWnd,szItem);
				}
				else {
					ErrorMessageBox(L"Fatal Error: Wrong boxtype given to CreateCombobox() second time\n");
					exit(0);
				}	
			}			
			
		} while(pszTemp);
		pszTemp = pszStart;
		pszStart = NULL;


		// jek
		// Fill in the szValues array with values - ie the values which is sent back to the server side
		DWORD dwTextLength2      = wcslen(bsValues) + 1;    
		WCHAR szTextItem2[256], szItem2[256];
		PWCHAR pszTemp2          = NULL, pszStart2;
		
		if (!(pszTemp2 = new WCHAR[dwTextLength2 + 1])) {
			MessageBox(L"Can't create new memory in function CreateComboBox",NULL,MB_OK);
			return E_OUTOFMEMORY;
		}


		wcscpy(szTextItem2,L"");
		pszStart2 = pszTemp2;
		memset(pszTemp2,0,dwTextLength2 * sizeof(WCHAR));
		wcscpy(pszTemp2,L";");
		wcscat(pszTemp2,bsValues);
		wchar_t wcStart2 = 0,wcEnd2 = ';'; // Start and end separator for parsing text
    	DWORD dwSize2    = 0;
		int i=0;
		do {
		//// MessageBox(L"In looooop",NULL,MB_OK);
			if(pszTemp2 = ParseInputText(pszTemp2,&szItem2[0],wcStart2,wcEnd2,&dwSize2)) {			
			wcscpy(szValues[i++],szItem2);
			}			
		} while(pszTemp2);
		pszTemp2 = pszStart2;
		pszStart2 = NULL;

		
		// We need to update the window title
		// -----------------------------------
		// SetWindowTextA(hWnd,"Select facility");
		//::SendMessage(hWnd, WM_SETTEXT, 0, (LPARAM)L"Select facility"); 
		::SendMessage(hWnd, WM_SETTEXT, 0, (LPARAM)bsTitle); 
	}



#ifdef PPC2002	
    ::UpdateWindow(hWnd); 
    ::ShowWindow(hWnd,SW_SHOW);
#endif

	if(pszTemp) delete pszTemp;
		pszTemp = NULL;

    // Add combo box (control) to a list of controls
    m_ControlList.AddTail(ct);

	// if(m_hf)
    // ::SendMessage(hWnd,CB_SHOWDROPDOWN,(WPARAM) m_hf,MAKELPARAM(true,0));



	
	return S_OK;
}
/////////////////////////////////////////////////////////////////////////////
// PROPERY:  Cmapview::RemoveImageColor
//
// COMMENT: Not in use 
//
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::get_RemoveImageColor(int * nRemoveImageColor)
{
	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////
// PROPERY:  Cmapview::RemoveImageColor
//
// COMMENT: This variable is used when we want to remove a color
//          from an image. The color to remove is the image threshold 
//          color (see the method ImageThresholdColorRGB). Example: 
//          we can remove the color white (RGB(255,255,255)) from an icon,
//          to get a transparent image on a background image. 
//
//
//
// PARAMS:  nRemoveImageColor - TRUE if we want to remove color 
//          from an image.
//
/////////////////////////////////////////////////////////////////////////////          
STDMETHODIMP Cmapview::put_RemoveImageColor(int nRemoveImageColor)
{

	if(nRemoveImageColor == 0)
		m_dwRemoveImageColor = 0;
	else if(nRemoveImageColor == 1)
		m_dwRemoveImageColor = 1;
	else if(nRemoveImageColor == 2)
		m_dwRemoveImageColor = 2;

	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////
// PROPERY:  Cmapview::BorderWidth
//
// COMMENT: Not in use 
//
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::get_PenWidth(int * nPenWidth)
{
	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////
// PROPERY: Cmapview::BorderWidth
//
// COMMENT: Set the painted border width.
//
// PARAMS:  nBorderWidth - painted order width 
//
/////////////////////////////////////////////////////////////////////////////     

STDMETHODIMP Cmapview::put_PenWidth(int nPenWidth)
{
	if(nPenWidth > 0)
		m_dwPenWidth = nPenWidth;

	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////
// PROPERY:  Cmapview::get_TransparentHotspotEvent
//
// COMMENT: Not in use 
//
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::get_TransparentHotspotEvent(int * nTransparentHotspotEvent)
{   
	return S_OK;
}


STDMETHODIMP Cmapview::put_TransparentHotspotEvent(int nTransparentHotspotEvent)
{

	if(nTransparentHotspotEvent > 0)
		m_bTransparentHotspotEvent = true;
	else
		m_bTransparentHotspotEvent = false;

	return S_OK;
}


/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::Font
//
// COMMENT: Create a font.  
//
// PARAMS:  bsType - Font type. Example: "Arial"
//          nSize - Font size. Example: 18
//          nItalic - Italic text if value is TRUE
//          nUndeline - Underline text if value is TRUE
//          nTransparent - Transparent background for the text if the value
//          is TRUE, else the background colour is created by the method
//          TextBkColorRGB (see below).
//
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::Font(BSTR bsType, int nSize, int nItalic,int nUndeline, int nTransparent)
{   

    if(nUndeline)
        m_bUnderline = TRUE;
    else
        m_bUnderline = FALSE;
    if(nSize) 
        m_dwFontSize = nSize;
    if(nTransparent)
        m_bTransparent = TRUE;
    else
        m_bTransparent = FALSE;
    if(nItalic)
        m_bItalic = TRUE;
    else
        m_bItalic = FALSE;

    if(nSize)
        m_dwFontSize = nSize;
    
    wcscpy(m_szFontType,bsType);

        
    return S_OK;
}
/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::BorderColorRGB
//
// COMMENT: Border colour for the painted shape (rectangle or ellipse)  
//
// PARAMS:  byRed - Red colour (0-255)
//          byGreen - Green colour (0-255)
//          byBlue - Blue colour (0-255)
//
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::BorderColorRGB(int byRed, int byGreen, int byBlue)
{

    m_crBorderColor = RGB((BYTE)byRed,(BYTE)byGreen,(BYTE)byBlue);

    return S_OK;
}
/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::EventBorderColorRGB
//
// COMMENT: Border colour for the shape (rectangle or ellipse) that is painted
//          when the pen is pushed on a hotspot  
//
// PARAMS:  byRed - Red colour (0-255)
//          byGreen - Green colour (0-255)
//          byBlue - Blue colour (0-255)
//
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::EventBorderColorRGB(int byRed, int byGreen, int byBlue)
{

    m_crEventBorderColor = RGB((BYTE)byRed,(BYTE)byGreen,(BYTE)byBlue);

    return S_OK;
}
/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::FillerColorRGB
//
// COMMENT: Fill the shape (ellipse/rectangle/text) with this colour.  
//
// PARAMS:  byRed - Red colour (0-255)
//          byGreen - Green colour (0-255)
//          byBlue - Blue colour (0-255)
//
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::FillerColorRGB(int byRed, int byGreen, int byBlue)
{

    m_crFillerColor = RGB((BYTE)byRed,(BYTE)byGreen,(BYTE)byBlue);

    return S_OK;
}
/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::EventFillerColorRGB
//
// COMMENT: Fill the shape (ellipse/rectangle), that is painted when an event
//          is generated from a hotspot, with this colour.  
//
// PARAMS:  byRed - Red colour (0-255)
//          byGreen - Green colour (0-255)
//          byBlue - Blue colour (0-255)
//
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::EventFillerColorRGB(int byRed, int byGreen, int byBlue)
{

    m_crEventFillerColor = RGB((BYTE)byRed,(BYTE)byGreen,(BYTE)byBlue);

    return S_OK;
}
/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::TextColorRGB
//
// COMMENT: Text colour  
//
// PARAMS:  byRed - Red colour (0-255)
//          byGreen - Green colour (0-255)
//          byBlue - Blue colour (0-255)
//
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::TextColorRGB(int byRed, int byGreen, int byBlue)
{

    m_crTextColor = RGB((BYTE)byRed,(BYTE)byGreen,(BYTE)byBlue);

    return S_OK;
} 
/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::ImageThresholdColorRGB
//
// COMMENT: Colour that is used as a threshold when an image is painted (
//          paint only that part of the image that is below this threshold). 
//
// PARAMS:  byRed - Red colour (0-255)
//          byGreen - Green colour (0-255)
//          byBlue - Blue colour (0-255)
//
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::ImageThresholdColorRGB(int byRed, int byGreen, int byBlue)
{

    m_crImageThresholdColor = RGB((BYTE)byRed,(BYTE)byGreen,(BYTE)byBlue);

	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////
// METHOD:  Cmapview::TextBkColorRGB
//
// COMMENT: The background colour for a text 
//
// PARAMS:  byRed - Red colour (0-255)
//          byGreen - Green colour (0-255)
//          byBlue - Blue colour (0-255)
//
/////////////////////////////////////////////////////////////////////////////
STDMETHODIMP Cmapview::TextBkColorRGB(int byRed, int byGreen, int byBlue)
{

    m_crTextBkColor = RGB((BYTE)byRed,(BYTE)byGreen,(BYTE)byBlue);

	return S_OK;
}

STDMETHODIMP Cmapview::StringIn(SAFEARRAY FAR * pItem)
{
	return S_OK;
}



STDMETHODIMP Cmapview::get_Control(BSTR * bsName)
{
    return S_OK;
}

STDMETHODIMP Cmapview::ActivateDebugWindow(int nLeft, int nTop, int nRight, int nBottom)
{
    /*HGLOBAL hEditDS = GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT | GMEM_SHARE, 256L);

    if(!m_hWndDebug) {
        m_hWndDebug = ::CreateWindow(
		    L"EDIT",
		    NULL,
		    WS_CHILD | WS_VISIBLE | WS_BORDER |WS_HSCROLL |WS_VSCROLL|ES_MULTILINE|ES_AUTOHSCROLL|ES_AUTOVSCROLL,
		    nLeft, nTop, nRight, nBottom, 
		    m_hWnd,
		    (HMENU)IDC_EDIT_DEBUG,
		    (HINSTANCE)ghInstance,
		    NULL
		    );	
    }*/
    return S_OK;
}
