// mapview.h : Declaration of the Cmapview

#ifndef __MAPVIEW_H_
#define __MAPVIEW_H_

#include "resource.h"       // main symbols
#include <atlbase.h>
#include <atlctl.h>

#include <atlwin.h>
#include <windowsx.h>
#include "voimage.h"

extern HANDLE   ghInstance;         // DLL library instance

#define IDC_BUTTON 110
#define IDC_MAP_BUTTON 111
#define IDC_EDIT   112
#define IDC_MAP_EDIT 113
#define IDC_COMBO  114
#define IDC_MAP_COMBO 115
#define IDC_EDIT_DEBUG 144
#define PAINT_TIMER_ID 100
#define WM_HOTSPOT 150
#define UPDATE_SCREEN_TIMER_ID 101
#define MAX_TEXT_SIZE 256



// jek
#define MAX_INDEX_COMBOBOXITEM      16
#define MAX_CARACTERS_COMBOBOXITEM  32



/////////////////////////////////////////////////////////////////////////////
// Cmapview
class ATL_NO_VTABLE Cmapview : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<Cmapview,&CLSID_mapview>,

	public IDispatchImpl<Imapview,&IID_Imapview,&LIBID_MAPCTRLLib>,
	public IProvideClassInfoImpl<&CLSID_mapview,&LIBID_MAPCTRLLib>,
	public CComControl<Cmapview>,
	public IOleControlImpl<Cmapview>,
	public IOleObjectImpl<Cmapview>,
	public IViewObjectExImpl<Cmapview>,
	public IOleInPlaceActiveObjectImpl<Cmapview>,
	public IOleInPlaceObjectWindowlessImpl<Cmapview>,
	public IPersistPropertyBagImpl<Cmapview>,
	public IObjectSafetyImpl<Cmapview, INTERFACESAFE_FOR_UNTRUSTED_CALLER | INTERFACESAFE_FOR_UNTRUSTED_DATA>
{
public:

Cmapview();
~Cmapview();


DECLARE_REGISTRY_RESOURCEID(IDR_MAPVIEW)

static LPCTSTR GetWindowClassName() {return TEXT("Cmapview");}


BEGIN_COM_MAP(Cmapview)
	COM_INTERFACE_ENTRY(Imapview)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY_IMPL(IOleControl)
	COM_INTERFACE_ENTRY_IMPL(IOleObject)
	COM_INTERFACE_ENTRY_IMPL(IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject2,IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject,IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleWindow,IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleInPlaceObject,IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleWindow,IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL(IPersistPropertyBag)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IPersist,IPersistPropertyBag)
	COM_INTERFACE_ENTRY(IObjectSafety)

END_COM_MAP()

BEGIN_PROPERTY_MAP(Cmapview)
    PROP_ENTRY("Control", 1, CLSID_mapview)
    PROP_ENTRY("ControlFontSize", 2, CLSID_mapview)
	PROP_ENTRY("RemoveImageColor", 23, CLSID_mapview)
	PROP_ENTRY("PenWidth", 24, CLSID_mapview)
	PROP_ENTRY("TransparentHotspotEvent", 25, CLSID_mapview)
END_PROPERTY_MAP()



BEGIN_MSG_MAP(Cmapview)
	MESSAGE_HANDLER(WM_COMMAND, OnCtrl)
	MESSAGE_HANDLER(WM_PAINT, OnPaint)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	MESSAGE_HANDLER(WM_KILLFOCUS, OnKillFocus)
	MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
	MESSAGE_HANDLER(WM_LBUTTONUP, OnLButtonUp)
    MESSAGE_HANDLER(WM_MOUSEMOVE,OnMouseMove)
    MESSAGE_HANDLER(WM_TIMER,OnTimer)
	//MESSAGE_HANDLER(WM_SETTINGCHANGE,OnSettingChange)
	CHAIN_MSG_MAP(CComControl<Cmapview>)
	//MESSAGE_HANDLER(WM_LBUTTONDBLCLK, OnRButtonDown)
END_MSG_MAP()

public:
    // Begin control attrib
	WCHAR    m_szInputText[256], m_szInfo[256], m_szCtrlName[50], m_szBuf[256];
	WCHAR    m_szTextOut[MAX_TEXT_SIZE], m_szCtrlText[100];
	WCHAR    m_szEditBoxName[50], m_szEditBoxText[MAX_TEXT_SIZE];
	WCHAR    m_szStaticText[100], m_szStaticTextID[100];
	WCHAR    m_szComboBoxName[100], m_szButtonName[20], * m_pszItems;
	DWORD	 m_dwCtrl, m_dwCtrlId, m_dwParamCnt; 
	DWORD    m_dwMenu, m_dwNumOfParam, m_dwStyle;
	HWND     m_hWndCtrl, m_hWndDebug;
	BOOL     m_bSetFocus;
	HFONT    m_hf;
	// End control attrib

	// Begin paint attrib.

	CVOImage * m_pImage;
	DWORD    m_dwMouseXPos, m_dwMouseYPos;
	DWORD    m_dwCursorOffsetX, m_dwCursorOffsetY;
	DWORD    m_ImageOffsetX, m_ImageOffsetY;
	DWORD    m_dwTextBkWidth;
	BOOL     m_bInfoIsPainted;
	BOOL     m_bRepaintPicture;
    COLORREF m_crBorderColor, m_crFillerColor, m_crTextColor;
    COLORREF m_crEventBorderColor, m_crEventFillerColor;
    COLORREF m_crImageThresholdColor, m_crTextBkColor;
    DWORD    m_dwFontSize, m_dwHotSpotCounter,m_dwEventCounter, m_dwControlCounter;
    BOOL     m_bUnderline, m_bTransparent, m_bItalic;
    WCHAR    m_szFontType[20], m_szDefaultPath[256];
	DWORD    m_dwRemoveImageColor, m_dwPenWidth;
	BOOL     m_bTransparentHotspotEvent;
	HRGN     m_hRgn;

    RECT    m_rectMouseText;
    HBITMAP m_BitmapMouseArea;
        
    // List of hotspots
    HOTSPOTLIST m_HotSpotList;

    // List of controls
    CONTROLLIST m_ControlList;
    
    // List of events 
    EVENTLIST m_EventList;

	// Example image:
	TCHAR m_szImageName[256];

    // End paint attrib

// Imapview
public:
    STDMETHOD(get_Control)(BSTR  * bsName);
	STDMETHOD(put_Control)(BSTR bsName);
	STDMETHOD(get_ControlFontSize)(int * nFontSize);
	STDMETHOD(put_ControlFontSize)(int  nFontSize);
	STDMETHOD(get_RemoveImageColor)(int * nRemoveImageColor);
    STDMETHOD(put_RemoveImageColor)(int nRemoveImageColor);
    STDMETHOD(get_PenWidth)(int * nPenWidth);
    STDMETHOD(put_PenWidth)(int nPenWidth);
	STDMETHOD(get_TransparentHotspotEvent)(int * nTransparentHotspotEvent);
    STDMETHOD(put_TransparentHotspotEvent)(int nTransparentHotspotEvent);
    STDMETHOD(BorderColorRGB)(int byRed, int byGreen, int byBlue);
    STDMETHOD(FillerColorRGB)(int byRed, int byGreen, int byBlue);
    STDMETHOD(EventBorderColorRGB)(int byRed, int byGreen, int byBlue);
    STDMETHOD(EventFillerColorRGB)(int byRed, int byGreen, int byBlue);
    STDMETHOD(TextColorRGB)(int byRed, int byGreen, int byBlue); 
    STDMETHOD(ImageThresholdColorRGB)(int byRed, int byGreen, int byBlue);
    STDMETHOD(TextBkColorRGB)(int byRed, int byGreen, int byBlue);
    STDMETHOD(CreatePaintedHotspot)(BSTR bsEventText, BSTR bsMouseText, BSTR bsShapeType, int nFiller, int nLeft, int nTop, int nRight, int nBottom);
    STDMETHOD(CreateImageHotspot)(BSTR bsEventText, BSTR bsMouseText, BSTR bsImageName, int nLeft, int nTop);
    STDMETHOD(CreateImageEvent)(BSTR bsEventText, BSTR bsEventImageName, int nLeft, int nTop);
	STDMETHOD(CreatePaintedEvent)(BSTR bsEventText, BSTR bsShapeType, int nFiller, int nLeft, int nTop, int nRight, int nBottom);
    STDMETHOD(Font)(BSTR bsType, int nSize,int nItalic, int nUndeline, int nTransparent);
    STDMETHOD(CreateButton)(BSTR sbButtonText,  BSTR sbEventText, BSTR sbSubmitText, int nLeft, int nTop, int nRight, int nBottom);
    STDMETHOD(CreateEditBox)(BSTR sbEditText, BSTR sbEventText, int nCloseButton, BSTR bsTitle, int nFocus, int nRaiseKeyboardOnFocus,int nDisable, int nLeft, int nTop, int nRight, int nBottom);
	STDMETHOD(CreateTextHotSpot)(BSTR sbText, BSTR sbEventText, int nDynamicSize, int nBorder, int nBorderWidth, int nLeft, int nTop,int nRight, int nBottom);
	STDMETHOD(CreateTextEvent)(BSTR sbText, BSTR sbEventText,int nBorder,int nBorderWidth, int nLeft,  int nTop,int nRight, int nBottom);
    STDMETHOD(ActivateDebugWindow)(int nLeft, int nTop, int nRight, int nBottom);
	STDMETHOD(CreateComboBox)(BSTR bsBoxType, BSTR sbComboBoxTitle, BSTR sbEventText,BSTR sbComboBoxItems, BSTR sbComboBoxValues, int nLeft, int nTop, int nRight, int nBottom);
	STDMETHOD(StringIn)(SAFEARRAY FAR * pItem);
	STDMETHOD(CreateTransparentHotspot)(BSTR bsEventText, BSTR bsMouseText, int nLeft, int nTop, int nRight, int nBottom);

    LRESULT OnLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL & bHandled);
	LRESULT OnLButtonUp(UINT uMsg, WPARAM wParam, LPARAM lParam,BOOL& bHandled); 
	LRESULT OnMouseMove(UINT uMsg, WPARAM wParam, LPARAM lParam,BOOL& bHandled); 
	LRESULT OnCtrl(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL & bHandled);
	LRESULT OnTimer(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL & bHandled);
    HRESULT OnDraw(ATL_DRAWINFO& di);

    void    AddToComboBox(HWND hWnd,PWCHAR szBuf);
	void    AddToListBox(HWND hWnd,PWCHAR szBuf);
	void    AddToCtrl(HWND hWnd);
	void    ChooseControl(BSTR szName, BOOL * pbCreateControl);
	PWCHAR  ParseInputText(wchar_t * pszInText, wchar_t * pszOutText, wchar_t wcStart, wchar_t wcEnd, PDWORD pdwSize); 
    void    RepaintAll();
    void    RemoveDisplay(HDC hdc,RECT rc); 
   
    static DWORD _GetMiscStatus();
    // For debug window
    void OUTPUT_TEXT(wchar_t * pszStr)
    {
     //if (m_hWndDebug) 
        //::SendMessage(m_hWndDebug,EM_REPLACESEL,FALSE,(LPARAM)pszStr);
    }


	BOOL bLBDown;
	POINT line[2];
	int left, right, top, bottom;
	short m_PenWidth;
};

#endif //__MAPVIEW_H_
