#include "nonClassMembers.h"
#include "winsock.h"


#ifndef __NCLASMEM_CPP
#define __NCLASMEM_CPP



//-------------------------------------
// Auxiliary function which reads an ALAW 
// file to a buffer
//--------------------------------------
int ReadBytesFromFile(PHANDLE   s, 
							 char *buf, 
							 int   n) {
	DWORD bcount;
	int status;
	int total_count,total_required;
	BOOL br;
	int ret_value=-1;
	
	bcount = 0;
	total_count=0; total_required=n;
	br = FALSE;
	
	while(1){	
		br = ReadFile(*s, (LPVOID)buf, (DWORD)n, &bcount, NULL );
		if (!br) {
			ret_value=-1;
			break; // Hopeless
		}
		else {
			if (bcount == 0){
				//fprintf(stderr, "ReadBytesFromFIFO: We have passed the EOF\n");
				ret_value=0;
				break;
			}
			
			else if (bcount > 0 ){
				total_count=total_count+bcount;
				if (total_count == total_required){
					ret_value=1;
				    break;
				}
				else
					n=n-bcount;
            }
			else{
				ret_value=-1;
				break;
			}
			
		}
	}
	if (ret_value >=0){
		for (int j=total_count;j<total_required;j++)
			buf[j]='\x55';
	}

	return ret_value;
	
};

//-------------------------------
// Auxiliary function to display
// windows error messages
//---------------------------------
int DisplayLastError(){
LPVOID lpMsgBuf;
			FormatMessage( 
				FORMAT_MESSAGE_ALLOCATE_BUFFER | 
				FORMAT_MESSAGE_FROM_SYSTEM | 
				FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL,
				GetLastError(),
				0, // Default language
				(LPTSTR) &lpMsgBuf,
				0,
				NULL 
				);
			// Process any inserts in lpMsgBuf.
			// ...
			// Display the string.
			MessageBox( NULL, (LPCTSTR)lpMsgBuf, L"Error", MB_OK | MB_ICONINFORMATION );
			// Free the buffer.
			LocalFree( lpMsgBuf );

			return 1;
};


//-----------------------------------------------------------
// Write a buffer to a socket
//-------------------------------------------------
int WriteSocket(SOCKET *s, char *buf, int n){


	if (*s == INVALID_SOCKET){
		return -1;
	}

    int ret_value=send(*s,buf,n,0);
	if (ret_value == SOCKET_ERROR){
		LPVOID lpMsgBuf;
		FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			WSAGetLastError(),
			0, // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
			);
		// Process any inserts in lpMsgBuf.
		// ...
		// Display the string.
		MessageBox( NULL, (LPCTSTR)lpMsgBuf, L"Error", MB_OK | MB_ICONINFORMATION );
		// Free the buffer.
		LocalFree( lpMsgBuf );
		return -1;
	}
    else
		return ret_value;

}


#endif