#ifndef __SOCKET_STR_CPP__
#define __SOCKET_STR_CPP__

#include "socket_str.h"


//----------------------------------------------------
// Constructor
//-----------------------------------------------------
socket_stream::socket_stream(char *ip_address,int port){

  // Initialize Winsocket. 
  if (WSAStartup (MAKEWORD(1,1), &m_hWSAData) != 0) 
  {
    wsprintf (szError, TEXT("WSAStartup failed. Error: %d"), 
              WSAGetLastError ());
    MessageBox (NULL, szError, TEXT("Error"), MB_OK);
   // return FALSE;
  }

  connectToServer(ip_address,port);
     
}


//-------------------------------------------
// EStablishs the connecti to the server
//-------------------------------------------  
int socket_stream::connectToServer(char *ip_address, int port){

	

  // Create a TCP/IP socket that is bound to the server.
  if ((m_hSocket = socket (AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET)
  {
    wsprintf (szError, TEXT("Allocating socket failed. Error: %d"), 
              WSAGetLastError ());
    MessageBox (NULL, szError, TEXT("Error"), MB_OK);
   // return FALSE;
  }



   GetHostByAddr(ip_address,port); 


  // Establish a connection to the server socket.
  if (connect (m_hSocket, 
               (PSOCKADDR) &m_hSockaddr, 
               sizeof (m_hSockaddr)) == SOCKET_ERROR) 
  {
    wsprintf (szError, 
              TEXT("Connecting to the server failed. Error: %d"),
              WSAGetLastError ());
    MessageBox (NULL, szError, TEXT("Error"), MB_OK);
    closesocket (m_hSocket);
   
  }
   
  return 1;
}


//-----------------------------
// Closes the 'send' connection
//------------------------------ 
int socket_stream::resetConnection(){
    shutdown(m_hSocket,1);
	//closesocket(m_hSocket);

	return 1;
}

//-------------------------
// Destructor
//------------------------------
socket_stream::~socket_stream(){
 // Close the socket.
  closesocket (m_hSocket);
  WSACleanup ();
}


//-----------------------------------------
// Support routine
//-----------------------------------------
SOCKADDR_IN * socket_stream::GetHostByAddr(char *IPadr, 
											  const USHORT ushPort)
{
	
	hostent*    host;
	struct      sockaddr_in sa;
	char        Hostname[256];
	//SOCKADDR_IN sockTemp;
	u_long      IPadress;
	
	switch (IPadress = ToIPAdr(IPadr)) {
	case 0:
		if ((host = gethostbyname(IPadr))) {
			strcpy(Hostname,host->h_name);
			memcpy (&sa.sin_addr,host->h_addr, host->h_length); 
		}
		else {
			
		}
		break;
	default:
		
		sa.sin_addr.s_addr = IPadress;		  		  
		if ((host = gethostbyaddr((char *)&(sa.sin_addr), 
			sizeof(sa.sin_addr), 
			AF_INET))) {
			memcpy (host->h_addr, (char *)&sa.sin_addr, host->h_length);
			sa.sin_family = host->h_addrtype;
			sa.sin_port = htons((u_short)ushPort);
		}
		else { 	
		}
		
	}
	
	ULONG* pulAddr = NULL;
	if(host == NULL) {
		
		
		m_hSockaddr.sin_family      = AF_INET;
		m_hSockaddr.sin_port        = htons(NULL);
		m_hSockaddr.sin_addr.s_addr = NULL;	

		// jek
		// SocketError(L"MUST_GetHostByAddr");
		
		// jek	- try it anyway - we ignore if no name servers available on domain
		char tmp[1024];
		strcpy(tmp,IPadr);
		int cnt   = 0;
		char *Addr[32+1];
		int index = 0;
		Addr[index++] = &tmp[0];
		while (tmp[cnt] != '\0') {
			if (tmp[cnt] == '.') {
				tmp[cnt]      = 0;
				Addr[index++] = &tmp[cnt+1];
			}
			cnt++;
		}  
		int addr0_i,addr1_i,addr2_i,addr3_i;
		sscanf(Addr[0], "%i", &addr0_i);
		sscanf(Addr[1], "%i", &addr1_i); 
		sscanf(Addr[2], "%i", &addr2_i);
		sscanf(Addr[3], "%i", &addr3_i);
		tmp[0] = (char)addr0_i;
		tmp[1] = (char)addr1_i;
		tmp[2] = (char)addr2_i;
		tmp[3] = (char)addr3_i;
		
		pulAddr                  = (ULONG*) tmp;
		m_hSockaddr.sin_family      = AF_INET;
		m_hSockaddr.sin_port        = htons(ushPort);
		m_hSockaddr.sin_addr.s_addr = *pulAddr; // address is already in network byte order
		
		
	}
	else {
		if(host) pulAddr = (ULONG*) host->h_addr_list[0];
		m_hSockaddr.sin_family = AF_INET;
		m_hSockaddr.sin_port = htons(ushPort);
		if(host) m_hSockaddr.sin_addr.s_addr = *pulAddr; // address is already in network byte order
	}
	return &m_hSockaddr;
}

  



//-------------------------------------------------------------
// Static Function: ToIPAdr(char *host)
//                 convert string "n1.n2.n3.n4" to IP-adress
//                 Stricter than inet_addr(): returns zero if
//                 there are not four groups of decimal integers
//                 of value 0 - 255, separated by '.' in the string
//
// Return value: IP-adress, or 0 if format error
//--------------------------------------------------------------

u_long socket_stream::ToIPAdr(char *hname) {

  char c, *p, hostname[32];
  long ipadr = 0;
  int i, tmp;

  if (strlen(hname) > 31) return(0);

  p = strcpy(hostname, hname);


  while((c = *p++) != '\0') {
	if ((c != '.') && ( (c < '0') || (c > '9') ) ) return(0);
  }

  p = strtok(hostname, ".");
  for(i = 0; i < 4; i++) {
    if (p == NULL) return(0);
    if (((tmp = atoi(p)) > 255) || (tmp < 0)) return(0);
    ipadr = (ipadr << 8) + tmp;
    p = strtok(NULL, ".");
  }
  return htonl(ipadr);
}


//-----------------------------------------
// Support routine to display Windows error messages
//---------------------------------------
int socket_stream::display_error(){
	LPVOID lpMsgBuf;
	FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			WSAGetLastError(),
			0, // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
			);
		// Process any inserts in lpMsgBuf.
		// ...
		// Display the string.
		MessageBox( NULL, (LPCTSTR)lpMsgBuf, L"Error", MB_OK | MB_ICONINFORMATION );
		// Free the buffer.
		LocalFree( lpMsgBuf );

		return 1;

}


//------------------------------------------------------
// Writes data to the socket
//------------------------------------------------------
int socket_stream::write(char *buf, int buf_length)
{

// Send a string to the server.
  if (send (m_hSocket, buf, buf_length, 0)
           == SOCKET_ERROR) 
  {
    wsprintf (szError, 
              TEXT("Sending data to the server failed. Error: %d"),
              WSAGetLastError ());
    MessageBox (NULL, szError, TEXT("Error"), MB_OK);
	return 0;
  }

  // Disable sending on ServerSock.
  //shutdown (m_hSocket, 0x01);
  return buf_length;
}



//----------------------------------------------------------------
// This routine reads a (speech) data buffer sent by the server.
// The buffer size sent by the server and the size this routine 
// tries to read must be the same. (i.e. Server appends zeros, if
// the data cannot be broken into a set of equal length buffers).
// This routine returns if (a) there is a socket error or (b) socket
// has been reset by the peer or (c) waiting time expires or (d)the
// buffer is filled by the data read.
// 
// Note that the server appends a delimiter to the (speech)
// data. The calling routine of this function uses this data to determine 
// the waiting time.
//
// Arguments: buf: buffer to the data is read
//            buf_size: Required data buffer size (usually 160, eqv. to 20 ms speech
//            wait: waiting time in millisecods usually 20 (I guess)
//            info: Other info which can be returned by the rutine
//------------------------------------------------------------------  
int socket_stream::read(char *buf, int buf_size, int wait, void *info){
	
    int waiting_res;
	int buf_size_remained;
	char *buf_st;

	fd_set readfds;
	struct timeval  tval,*t;
	DWORD start_time, current_time;
	
    start_time=GetTickCount(); //
	buf_size_remained=buf_size;
	buf_st=buf;

	//create fdset
	FD_ZERO(&readfds);
	FD_SET(m_hSocket, &readfds);
	
	//Create the timeval structure
	if (wait !=0){
		tval.tv_sec=0;
		tval.tv_usec=wait*1000;
		t=&tval;
	}
	else{
		t=NULL;
	}
	
    while(1){

		if (wait != 0){
			current_time=GetTickCount();
			if (current_time-start_time > wait){
				//printf(">>>>>>>>>>>>>>>>>>>>>>\n");
				return buf_size-buf_size_remained;
			}
			
			tval.tv_usec=1000*(wait-current_time+start_time);
			t=&tval;
		}

		//Wait until the data is available 
		waiting_res= select(1,&readfds,NULL,NULL, t);
		
		
		if (waiting_res ==0){
//			printf("<<<<<<<<<<<<<\n");
			if (info != NULL)
				*((int *)info)=1; //Indicates a time out
			return (buf_size-buf_size_remained);  //no data (0), or less data
		}
		//Problematic situation
		else if (waiting_res == SOCKET_ERROR){
			wsprintf (szError, 
				TEXT("Waiting failed. Error: %d"),
				WSAGetLastError());
			MessageBox (NULL, szError, TEXT("Error"), MB_OK);
			return -1;
		}
		//Succeeded in waiting
		else{  
			
			// Receive data from the server socket.
			int  iReturn = recv (m_hSocket, buf_st, buf_size_remained, 0);
			
			// Check if there is any data received. 
			if (iReturn == SOCKET_ERROR) //Error situation
			{
				//wsprintf (szError, TEXT("No data is received, recv failed.")
				//	TEXT(" Error: %d"), WSAGetLastError ());
				//MessageBox (NULL, szError, TEXT("Client"), MB_OK);
#ifdef _MSG_TO_SCREEN_
				display_error();
#endif
				return -1;
			}
			else if (iReturn == 0) //Connection gracefully closed by peer
			{
				//printf("finished receiveing data\n");
				//MessageBox (NULL, TEXT("Finished receiving data"), TEXT("Client"),
				//MB_OK);
//				printf("---------------here2\n");
				return 0;
			}
			else {
				if (iReturn == buf_size_remained){
//					printf("###########here =%d\n", buf_size);
					return buf_size;
				}
				else{ //Not all the required data have been read
					buf_st=buf_st+iReturn;
					buf_size_remained=buf_size_remained-iReturn;
				}

			}
			
		}
	}
   
}



//---------------------------------------------------
// Wrapper to the above
//---------------------------------------------------
int socket_stream::read(char *buf, int buf_size, int wait){
	return read(buf,buf_size, wait,NULL); 
}
  




#endif
