/*******************************************************
  A Speech Detector based on the algorithm given in HTKBook

  Author: Narada Warakagoda
  
*********************************************************/

#ifndef __VAD_HH__
#define __VAD_HH__

//#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include <windows.h>

extern int dbg_;

class Vad
{

private:
  double speechthresh ; //thres. for speech above sil level
  double  silenergy  ; // Average bg noise level dB
  int  spcseqcount  ; // window over which speech/silence decision 
  int spcglchcount ;// max sil frames before speech onset
  int silseqcount ; // number of sil frames for end of speech
  int silglchcount; // number of sil frames before end of speech
  int silmargin; //margin in frames
  
  int sampling_rate; // In hertz
  int buffer_size; // In samples
  int frame_length; // in samples
  int frame_period; // in samples
  
  int frame_buffer_size;
  // 0 before speech on-set, 1 after speech on-set, 2
  // buffering state
  int status; 
  int window_status_current;
  

  int samp_per_window;
  char *sample_buffer;
  char *sample_buffer_pos;

  int buffered_samples;
  
  // int *decision_window; // 0 -> sil, 1 -> speech 
  
  int speech_frame_cnt;
  int silence_window_cnt;
  int window_cnt;
  

public:
  Vad(); // Constructor
  ~Vad(); // Destructor

  //Determine if the windo of len speech_or_not. Returrn value =
  // -2 -> Non-speech
  // -1 -> Cannot determine now, please wait
  //  0 -> Mid-Speech just further process the windo
   // 1 -> Start speech, retrieve the speech samples by calling
  //       getSpeechWindows()
  //  2 -> Speech after mid-silence, retrieve speech samples by
  //       calling getSpeechWindows() 
  //  3 -> End of speech, retrieve the speech samples by calling
  //       getSpeechWindows() 
  int IsSpeech(char *windo, int len);

  //gives the buffred speech which could not be determined previously
  char *getSpeechWindows();

  // gives the number of of speech samples which could not ve
  // determined previously  
  int  getSpeechWindowsLen(); 


};



#define LOG10(x) 0.43429435*log(x) 

inline  void MSG_(char *x)   {
  if (dbg_ == 1) 
  {}
  //cerr << x << endl;
}

#endif

