#include "voip.h"

#ifndef __VOIP_CPP
#define __VOIP_CPP

//------------------------
//Constructor
//-------------------------
VoIP::VoIP(HWND hwnd){
	m_hwnd = hwnd;
	verbosed=0;

}

	//------------------------------
// Start the voip operation
//------------------------------
int VoIP::Start(char *ip_address, int port ){

	ss = new socket_stream(ip_address, port);
	wrobj= new WavRec(ss, m_hwnd);
	wpobj = new WavPly(ss,m_hwnd);

	wrobj->setVerbosity(verbosed);
	wpobj->setVerbosity(verbosed);

	if (verbosed == 1){
		VoipLog = fopen("voip_log.txt", "w");
		wrobj->setLogFD(VoipLog);
		wpobj->setLogFD(VoipLog);
	}
    
#ifdef NO_BARGEIN
	//Sync *
	sobj = new Sync();
	wrobj->addSync(sobj);
	wpobj->addSync(sobj);
#endif
	
	wrobj->startRec();
	wpobj->startPlay();

	return 1;
}


//----------------------------
//Stop the voip operation
//----------------------------
int VoIP::Stop(){

	wrobj->stopRec();
	wrobj->waitRec();
    
	if (verbosed == 1)
		fprintf(VoipLog,"resetting connection\n");   
	ss->resetConnection(); // Closes the 'send' end
    
	wpobj->stopPlay();
	if (verbosed == 1)
		fprintf(VoipLog,"play stopped\n"); 
	wpobj->waitPlay();

	delete wrobj;
	delete wpobj;

    delete ss;

#ifdef NO_BARGEIN
	 delete sobj;
#endif
	 if (verbosed){
		 fclose(VoipLog);
	 }
	return 1;
}


//-----------------------------
// Controls the verbosity
//---------------------------
void VoIP::setVerbosity(int v){
	verbosed=v;
}


//-----------------------------
//Turns the recording microphone off
//------------------------------
void VoIP::set_micOff(){
	if (mic_off ==0) {//
		mic_off=1;
		wrobj->set_micOff();
	}

}

//----------------------------------
//Turns the recotrding microphone on
//---------------------------------
void VoIP::set_micOn(){
	if (mic_off ==1){
		mic_off=0;
		wrobj->set_micOn();
	}
}
#endif
