#ifndef __WAVPLY_HH__
#define __WAVPLY_HH__

#include <windows.h>
#include <stdio.h>

#include <mmsystem.h>
#include <mmreg.h>
#include <malloc.h>
#include "socket_str.h"
#include "tables.h"
#include "nonClassMembers.h"
#include "sync.h"  

#define NORMAL 10
#define START  20
#define LAST   30  

class WavPly{

private:
	
	//Standard windows audio data structures
	WAVEFORMATEX WaveFormat;
	HWAVEOUT	HWaveOut;
	DWORD		WaveBufSize;
	WAVEHDR     *newWaveHeader;  
	WAVEHDR *   curWaveHeader; 
	HANDLE		Event;

	//Socket to read data from 
	socket_stream *sock_str;
	TCHAR  errStr[100];
	
	/* Play status flag, pl_state==0 -> play yet to begin, pl_state=1 -> playing */
	int    pl_state;
	int WavDataRead;
	int delimiter_pos;
	char *residue;
	
	//File handles for logging and alaw reading from a file 
	HANDLE hLogFile;
	HANDLE hAlawFile;
	FILE   *LogFile;
	FILE *VoipLog_fd;
	
	int nQueued, QueueSize;
	int playStopped;
	int playStopped_forced;

	DWORD WaveBufSize_pcm;
	char *wavbuf_alaw;
	
	HWND parent_window;
	int time_out; 
	Sync *sync_obj;
	int buf_type;
	int buf_count;
	int verbosed;//=0;
	
public:
    HANDLE m_hPlayThread;
	HANDLE m_hCleanThread;
	DWORD  id_CleanThread;
	
	WavPly(socket_stream *server_soc, HWND parent_wnd);
	~WavPly();
	int QueueWaveData(WAVEHDR * waveHeader);
	int AquireData(WAVEHDR *waveHeader);
	
    int CleanWave(); 
	int PlayWave();
	
	void startPlay();
	void stopPlay();
	void waitPlay();
	int SetSampRate(int r);
    void setVerbosity(int v); 
	void setLogFD(FILE *fd);


#ifdef NO_BARGEIN
	void addSync(Sync *s);
#endif

	
	
};

extern "C" {
	

	void CALLBACK WaveOutProc(	HWAVEOUT waveOut, 
								UINT uMsg, 
								DWORD dwInstance, 
								DWORD dwParam1, 
								DWORD dwParam2);
	
	DWORD WINAPI playThread(VOID *vptr); 
	DWORD WINAPI cleanThread(VOID *vptr);
};


#endif