#ifndef __WAVREC_HH__
#define __WAVREC_HH__

#include <windows.h>
#include <stdio.h>

#include <mmsystem.h>
#include <mmreg.h>
#include <malloc.h>
#include "socket_str.h"
#include "tables.h"
#include "nonClassMembers.h"
#include "vad.h"
#include "sync.h"

class WavRec{

private:
	
	//Standard windows audio data structures
	WAVEFORMATEX WaveFormat;
	HWAVEIN	HWaveIn;
	DWORD		WaveBufSize;
	WAVEHDR     *newWaveHeader;  
	WAVEHDR *   curWaveHeader; 
	HANDLE		Event;

	//Socket to read data from 
	socket_stream *sock_str;
	TCHAR  errStr[100];
	
	/* Play status flag, pl_state==0 -> play yet to begin, pl_state=1 -> playing */
	int    pl_state;
	int WavDataWritten;
	int delimiter_pos;
	char *residue;
	
	//File handles for logging and alaw reading from a file 
	HANDLE hLogFile;
	HANDLE hAlawFile;
	FILE *LogFile;
	FILE *VoipLog_fd;
	
	int nQueued, QueueSize;
	int recStopped,recStopped_forced;

	DWORD WaveBufSize_pcm;
	char *wavbuf_alaw;
	
	HWND parent_window;
	Vad  *spdet;

	Sync *sync_obj;
	int verbosed;//=0;
	int mic_off;
	
public:
    HANDLE m_hRecThread;
	HANDLE m_hCleanThread;
	DWORD  id_CleanThread;
	
	WavRec(socket_stream *server_soc, HWND parent_wnd);
	~WavRec();
	int QueueWaveBuf(WAVEHDR * waveHeader);
	int ReleaseData(WAVEHDR *waveHeader);
	
    int CleanWave(); 
	int RecWave();
	
	void startRec();
	void stopRec();
	void waitRec();
	int SetSampRate(int r);
    void setVerbosity(int v); 
    void setLogFD(FILE *fd);

	void set_micOff();
	void set_micOn();


#ifdef NO_BARGEIN
	void addSync(Sync *s);
#endif
	
	
};



extern "C"{

void CALLBACK WaveInProc(	HWAVEIN waveOut, 
								UINT uMsg, 
								DWORD dwInstance, 
								DWORD dwParam1, 
								DWORD dwParam2);
	
	DWORD WINAPI recThread(VOID *vptr); 
	DWORD WINAPI RecCleanThread(VOID *vptr);
};


#endif